/* esm-bundle - @angular/material/bottom-sheet@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/cdk/dialog', '@angular/cdk/portal', '@angular/core', '@angular/material/core', '@angular/cdk/layout', '@angular/common', '@angular/animations', '@angular/cdk/a11y', '@angular/cdk/overlay', '@angular/cdk/keycodes', 'rxjs', 'rxjs/operators'], (function (exports) {
    'use strict';
    var i2, DialogModule, CdkDialogContainer, Dialog, i5, PortalModule, i0, Component, ChangeDetectionStrategy, ViewEncapsulation, Optional, Inject, NgModule, InjectionToken, Injectable, SkipSelf, EventEmitter, AnimationDurations, AnimationCurves, MatCommonModule, i4, Breakpoints, DOCUMENT, trigger, state, style, transition, group, animate, query, animateChild, i1, i3, ESCAPE, hasModifierKey, Subject, merge, filter, take;
    return {
        setters: [function (module) {
            i2 = module;
            DialogModule = module.DialogModule;
            CdkDialogContainer = module.CdkDialogContainer;
            Dialog = module.Dialog;
        }, function (module) {
            i5 = module;
            PortalModule = module.PortalModule;
        }, function (module) {
            i0 = module;
            Component = module.Component;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ViewEncapsulation = module.ViewEncapsulation;
            Optional = module.Optional;
            Inject = module.Inject;
            NgModule = module.NgModule;
            InjectionToken = module.InjectionToken;
            Injectable = module.Injectable;
            SkipSelf = module.SkipSelf;
            EventEmitter = module.EventEmitter;
        }, function (module) {
            AnimationDurations = module.AnimationDurations;
            AnimationCurves = module.AnimationCurves;
            MatCommonModule = module.MatCommonModule;
        }, function (module) {
            i4 = module;
            Breakpoints = module.Breakpoints;
        }, function (module) {
            DOCUMENT = module.DOCUMENT;
        }, function (module) {
            trigger = module.trigger;
            state = module.state;
            style = module.style;
            transition = module.transition;
            group = module.group;
            animate = module.animate;
            query = module.query;
            animateChild = module.animateChild;
        }, function (module) {
            i1 = module;
        }, function (module) {
            i3 = module;
        }, function (module) {
            ESCAPE = module.ESCAPE;
            hasModifierKey = module.hasModifierKey;
        }, function (module) {
            Subject = module.Subject;
            merge = module.merge;
        }, function (module) {
            filter = module.filter;
            take = module.take;
        }],
        execute: (function () {

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Animations used by the Material bottom sheet. */
            function MatBottomSheetContainer_ng_template_0_Template(rf, ctx) {}
            const matBottomSheetAnimations = exports('matBottomSheetAnimations', {
              /** Animation that shows and hides a bottom sheet. */
              bottomSheetState: trigger('state', [state('void, hidden', style({
                transform: 'translateY(100%)'
              })), state('visible', style({
                transform: 'translateY(0%)'
              })), transition('visible => void, visible => hidden', group([animate(`${AnimationDurations.COMPLEX} ${AnimationCurves.ACCELERATION_CURVE}`), query('@*', animateChild(), {
                optional: true
              })])), transition('void => visible', group([animate(`${AnimationDurations.EXITING} ${AnimationCurves.DECELERATION_CURVE}`), query('@*', animateChild(), {
                optional: true
              })]))])
            });

            /**
             * Internal component that wraps user-provided bottom sheet content.
             * @docs-private
             */
            class MatBottomSheetContainer extends CdkDialogContainer {
              constructor(elementRef, focusTrapFactory, document, config, checker, ngZone, overlayRef, breakpointObserver, _changeDetectorRef, focusMonitor) {
                super(elementRef, focusTrapFactory, document, config, checker, ngZone, overlayRef, focusMonitor);
                this._changeDetectorRef = _changeDetectorRef;
                /** The state of the bottom sheet animations. */
                this._animationState = 'void';
                /** Emits whenever the state of the animation changes. */
                this._animationStateChanged = new EventEmitter();
                this._breakpointSubscription = breakpointObserver.observe([Breakpoints.Medium, Breakpoints.Large, Breakpoints.XLarge]).subscribe(() => {
                  this._toggleClass('mat-bottom-sheet-container-medium', breakpointObserver.isMatched(Breakpoints.Medium));
                  this._toggleClass('mat-bottom-sheet-container-large', breakpointObserver.isMatched(Breakpoints.Large));
                  this._toggleClass('mat-bottom-sheet-container-xlarge', breakpointObserver.isMatched(Breakpoints.XLarge));
                });
              }
              /** Begin animation of bottom sheet entrance into view. */
              enter() {
                if (!this._destroyed) {
                  this._animationState = 'visible';
                  this._changeDetectorRef.detectChanges();
                }
              }
              /** Begin animation of the bottom sheet exiting from view. */
              exit() {
                if (!this._destroyed) {
                  this._animationState = 'hidden';
                  this._changeDetectorRef.markForCheck();
                }
              }
              ngOnDestroy() {
                super.ngOnDestroy();
                this._breakpointSubscription.unsubscribe();
                this._destroyed = true;
              }
              _onAnimationDone(event) {
                if (event.toState === 'visible') {
                  this._trapFocus();
                }
                this._animationStateChanged.emit(event);
              }
              _onAnimationStart(event) {
                this._animationStateChanged.emit(event);
              }
              _captureInitialFocus() {}
              _toggleClass(cssClass, add) {
                this._elementRef.nativeElement.classList.toggle(cssClass, add);
              }
            } exports('MatBottomSheetContainer', MatBottomSheetContainer);
            MatBottomSheetContainer.ɵfac = function MatBottomSheetContainer_Factory(t) {
              return new (t || MatBottomSheetContainer)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.FocusTrapFactory), i0.ɵɵdirectiveInject(DOCUMENT, 8), i0.ɵɵdirectiveInject(i2.DialogConfig), i0.ɵɵdirectiveInject(i1.InteractivityChecker), i0.ɵɵdirectiveInject(i0.NgZone), i0.ɵɵdirectiveInject(i3.OverlayRef), i0.ɵɵdirectiveInject(i4.BreakpointObserver), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1.FocusMonitor));
            };
            MatBottomSheetContainer.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatBottomSheetContainer,
              selectors: [["mat-bottom-sheet-container"]],
              hostAttrs: ["tabindex", "-1", 1, "mat-bottom-sheet-container"],
              hostVars: 4,
              hostBindings: function MatBottomSheetContainer_HostBindings(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵsyntheticHostListener("@state.start", function MatBottomSheetContainer_animation_state_start_HostBindingHandler($event) {
                    return ctx._onAnimationStart($event);
                  })("@state.done", function MatBottomSheetContainer_animation_state_done_HostBindingHandler($event) {
                    return ctx._onAnimationDone($event);
                  });
                }
                if (rf & 2) {
                  i0.ɵɵattribute("role", ctx._config.role)("aria-modal", ctx._config.ariaModal)("aria-label", ctx._config.ariaLabel);
                  i0.ɵɵsyntheticHostProperty("@state", ctx._animationState);
                }
              },
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 1,
              vars: 0,
              consts: [["cdkPortalOutlet", ""]],
              template: function MatBottomSheetContainer_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵtemplate(0, MatBottomSheetContainer_ng_template_0_Template, 0, 0, "ng-template", 0);
                }
              },
              dependencies: [i5.CdkPortalOutlet],
              styles: [".mat-bottom-sheet-container{padding:8px 16px;min-width:100vw;box-sizing:border-box;display:block;outline:0;max-height:80vh;overflow:auto}.cdk-high-contrast-active .mat-bottom-sheet-container{outline:1px solid}.mat-bottom-sheet-container-xlarge,.mat-bottom-sheet-container-large,.mat-bottom-sheet-container-medium{border-top-left-radius:4px;border-top-right-radius:4px}.mat-bottom-sheet-container-medium{min-width:384px;max-width:calc(100vw - 128px)}.mat-bottom-sheet-container-large{min-width:512px;max-width:calc(100vw - 256px)}.mat-bottom-sheet-container-xlarge{min-width:576px;max-width:calc(100vw - 384px)}"],
              encapsulation: 2,
              data: {
                animation: [matBottomSheetAnimations.bottomSheetState]
              }
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatBottomSheetContainer, [{
                type: Component,
                args: [{
                  selector: 'mat-bottom-sheet-container',
                  changeDetection: ChangeDetectionStrategy.Default,
                  encapsulation: ViewEncapsulation.None,
                  animations: [matBottomSheetAnimations.bottomSheetState],
                  host: {
                    'class': 'mat-bottom-sheet-container',
                    'tabindex': '-1',
                    '[attr.role]': '_config.role',
                    '[attr.aria-modal]': '_config.ariaModal',
                    '[attr.aria-label]': '_config.ariaLabel',
                    '[@state]': '_animationState',
                    '(@state.start)': '_onAnimationStart($event)',
                    '(@state.done)': '_onAnimationDone($event)'
                  },
                  template: "<ng-template cdkPortalOutlet></ng-template>\r\n",
                  styles: [".mat-bottom-sheet-container{padding:8px 16px;min-width:100vw;box-sizing:border-box;display:block;outline:0;max-height:80vh;overflow:auto}.cdk-high-contrast-active .mat-bottom-sheet-container{outline:1px solid}.mat-bottom-sheet-container-xlarge,.mat-bottom-sheet-container-large,.mat-bottom-sheet-container-medium{border-top-left-radius:4px;border-top-right-radius:4px}.mat-bottom-sheet-container-medium{min-width:384px;max-width:calc(100vw - 128px)}.mat-bottom-sheet-container-large{min-width:512px;max-width:calc(100vw - 256px)}.mat-bottom-sheet-container-xlarge{min-width:576px;max-width:calc(100vw - 384px)}"]
                }]
              }], function () {
                return [{
                  type: i0.ElementRef
                }, {
                  type: i1.FocusTrapFactory
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [DOCUMENT]
                  }]
                }, {
                  type: i2.DialogConfig
                }, {
                  type: i1.InteractivityChecker
                }, {
                  type: i0.NgZone
                }, {
                  type: i3.OverlayRef
                }, {
                  type: i4.BreakpointObserver
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: i1.FocusMonitor
                }];
              }, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatBottomSheetModule {} exports('MatBottomSheetModule', MatBottomSheetModule);
            MatBottomSheetModule.ɵfac = function MatBottomSheetModule_Factory(t) {
              return new (t || MatBottomSheetModule)();
            };
            MatBottomSheetModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatBottomSheetModule
            });
            MatBottomSheetModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              imports: [DialogModule, MatCommonModule, PortalModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatBottomSheetModule, [{
                type: NgModule,
                args: [{
                  imports: [DialogModule, MatCommonModule, PortalModule],
                  exports: [MatBottomSheetContainer, MatCommonModule],
                  declarations: [MatBottomSheetContainer]
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Injection token that can be used to access the data that was passed in to a bottom sheet. */
            const MAT_BOTTOM_SHEET_DATA = exports('MAT_BOTTOM_SHEET_DATA', new InjectionToken('MatBottomSheetData'));
            /**
             * Configuration used when opening a bottom sheet.
             */
            class MatBottomSheetConfig {
              constructor() {
                /** Data being injected into the child component. */
                this.data = null;
                /** Whether the bottom sheet has a backdrop. */
                this.hasBackdrop = true;
                /** Whether the user can use escape or clicking outside to close the bottom sheet. */
                this.disableClose = false;
                /** Aria label to assign to the bottom sheet element. */
                this.ariaLabel = null;
                /** Whether this is a modal bottom sheet. Used to set the `aria-modal` attribute. */
                this.ariaModal = true;
                /**
                 * Whether the bottom sheet should close when the user goes backwards/forwards in history.
                 * Note that this usually doesn't include clicking on links (unless the user is using
                 * the `HashLocationStrategy`).
                 */
                this.closeOnNavigation = true;
                // Note that this is set to 'dialog' by default, because while the a11y recommendations
                // are to focus the first focusable element, doing so prevents screen readers from reading out the
                // rest of the bottom sheet content.
                /**
                 * Where the bottom sheet should focus on open.
                 * @breaking-change 14.0.0 Remove boolean option from autoFocus. Use string or
                 * AutoFocusTarget instead.
                 */
                this.autoFocus = 'dialog';
                /**
                 * Whether the bottom sheet should restore focus to the
                 * previously-focused element, after it's closed.
                 */
                this.restoreFocus = true;
              }
            } exports('MatBottomSheetConfig', MatBottomSheetConfig);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Reference to a bottom sheet dispatched from the bottom sheet service.
             */
            class MatBottomSheetRef {
              /** Instance of the component making up the content of the bottom sheet. */
              get instance() {
                return this._ref.componentInstance;
              }
              constructor(_ref, config, containerInstance) {
                this._ref = _ref;
                /** Subject for notifying the user that the bottom sheet has opened and appeared. */
                this._afterOpened = new Subject();
                this.containerInstance = containerInstance;
                this.disableClose = config.disableClose;
                // Emit when opening animation completes
                containerInstance._animationStateChanged.pipe(filter(event => event.phaseName === 'done' && event.toState === 'visible'), take(1)).subscribe(() => {
                  this._afterOpened.next();
                  this._afterOpened.complete();
                });
                // Dispose overlay when closing animation is complete
                containerInstance._animationStateChanged.pipe(filter(event => event.phaseName === 'done' && event.toState === 'hidden'), take(1)).subscribe(() => {
                  clearTimeout(this._closeFallbackTimeout);
                  this._ref.close(this._result);
                });
                _ref.overlayRef.detachments().subscribe(() => {
                  this._ref.close(this._result);
                });
                merge(this.backdropClick(), this.keydownEvents().pipe(filter(event => event.keyCode === ESCAPE))).subscribe(event => {
                  if (!this.disableClose && (event.type !== 'keydown' || !hasModifierKey(event))) {
                    event.preventDefault();
                    this.dismiss();
                  }
                });
              }
              /**
               * Dismisses the bottom sheet.
               * @param result Data to be passed back to the bottom sheet opener.
               */
              dismiss(result) {
                if (!this.containerInstance) {
                  return;
                }
                // Transition the backdrop in parallel to the bottom sheet.
                this.containerInstance._animationStateChanged.pipe(filter(event => event.phaseName === 'start'), take(1)).subscribe(event => {
                  // The logic that disposes of the overlay depends on the exit animation completing, however
                  // it isn't guaranteed if the parent view is destroyed while it's running. Add a fallback
                  // timeout which will clean everything up if the animation hasn't fired within the specified
                  // amount of time plus 100ms. We don't need to run this outside the NgZone, because for the
                  // vast majority of cases the timeout will have been cleared before it has fired.
                  this._closeFallbackTimeout = setTimeout(() => {
                    this._ref.close(this._result);
                  }, event.totalTime + 100);
                  this._ref.overlayRef.detachBackdrop();
                });
                this._result = result;
                this.containerInstance.exit();
                this.containerInstance = null;
              }
              /** Gets an observable that is notified when the bottom sheet is finished closing. */
              afterDismissed() {
                return this._ref.closed;
              }
              /** Gets an observable that is notified when the bottom sheet has opened and appeared. */
              afterOpened() {
                return this._afterOpened;
              }
              /**
               * Gets an observable that emits when the overlay's backdrop has been clicked.
               */
              backdropClick() {
                return this._ref.backdropClick;
              }
              /**
               * Gets an observable that emits when keydown events are targeted on the overlay.
               */
              keydownEvents() {
                return this._ref.keydownEvents;
              }
            } exports('MatBottomSheetRef', MatBottomSheetRef);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Injection token that can be used to specify default bottom sheet options. */
            const MAT_BOTTOM_SHEET_DEFAULT_OPTIONS = exports('MAT_BOTTOM_SHEET_DEFAULT_OPTIONS', new InjectionToken('mat-bottom-sheet-default-options'));
            /**
             * Service to trigger Material Design bottom sheets.
             */
            class MatBottomSheet {
              /** Reference to the currently opened bottom sheet. */
              get _openedBottomSheetRef() {
                const parent = this._parentBottomSheet;
                return parent ? parent._openedBottomSheetRef : this._bottomSheetRefAtThisLevel;
              }
              set _openedBottomSheetRef(value) {
                if (this._parentBottomSheet) {
                  this._parentBottomSheet._openedBottomSheetRef = value;
                } else {
                  this._bottomSheetRefAtThisLevel = value;
                }
              }
              constructor(_overlay, injector, _parentBottomSheet, _defaultOptions) {
                this._overlay = _overlay;
                this._parentBottomSheet = _parentBottomSheet;
                this._defaultOptions = _defaultOptions;
                this._bottomSheetRefAtThisLevel = null;
                this._dialog = injector.get(Dialog);
              }
              open(componentOrTemplateRef, config) {
                const _config = Object.assign(Object.assign({}, this._defaultOptions || new MatBottomSheetConfig()), config);
                let ref;
                this._dialog.open(componentOrTemplateRef, Object.assign(Object.assign({}, _config), {
                  // Disable closing since we need to sync it up to the animation ourselves.
                  disableClose: true,
                  // Disable closing on detachments so that we can sync up the animation.
                  closeOnOverlayDetachments: false,
                  maxWidth: '100%',
                  container: MatBottomSheetContainer,
                  scrollStrategy: _config.scrollStrategy || this._overlay.scrollStrategies.block(),
                  positionStrategy: this._overlay.position().global().centerHorizontally().bottom('0'),
                  templateContext: () => ({
                    bottomSheetRef: ref
                  }),
                  providers: (cdkRef, _cdkConfig, container) => {
                    ref = new MatBottomSheetRef(cdkRef, _config, container);
                    return [{
                      provide: MatBottomSheetRef,
                      useValue: ref
                    }, {
                      provide: MAT_BOTTOM_SHEET_DATA,
                      useValue: _config.data
                    }];
                  }
                }));
                // When the bottom sheet is dismissed, clear the reference to it.
                ref.afterDismissed().subscribe(() => {
                  // Clear the bottom sheet ref if it hasn't already been replaced by a newer one.
                  if (this._openedBottomSheetRef === ref) {
                    this._openedBottomSheetRef = null;
                  }
                });
                if (this._openedBottomSheetRef) {
                  // If a bottom sheet is already in view, dismiss it and enter the
                  // new bottom sheet after exit animation is complete.
                  this._openedBottomSheetRef.afterDismissed().subscribe(() => {
                    var _a;
                    return (_a = ref.containerInstance) === null || _a === void 0 ? void 0 : _a.enter();
                  });
                  this._openedBottomSheetRef.dismiss();
                } else {
                  // If no bottom sheet is in view, enter the new bottom sheet.
                  ref.containerInstance.enter();
                }
                this._openedBottomSheetRef = ref;
                return ref;
              }
              /**
               * Dismisses the currently-visible bottom sheet.
               * @param result Data to pass to the bottom sheet instance.
               */
              dismiss(result) {
                if (this._openedBottomSheetRef) {
                  this._openedBottomSheetRef.dismiss(result);
                }
              }
              ngOnDestroy() {
                if (this._bottomSheetRefAtThisLevel) {
                  this._bottomSheetRefAtThisLevel.dismiss();
                }
              }
            } exports('MatBottomSheet', MatBottomSheet);
            MatBottomSheet.ɵfac = function MatBottomSheet_Factory(t) {
              return new (t || MatBottomSheet)(i0.ɵɵinject(i3.Overlay), i0.ɵɵinject(i0.Injector), i0.ɵɵinject(MatBottomSheet, 12), i0.ɵɵinject(MAT_BOTTOM_SHEET_DEFAULT_OPTIONS, 8));
            };
            MatBottomSheet.ɵprov = /* @__PURE__ */i0.ɵɵdefineInjectable({
              token: MatBottomSheet,
              factory: MatBottomSheet.ɵfac,
              providedIn: MatBottomSheetModule
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatBottomSheet, [{
                type: Injectable,
                args: [{
                  providedIn: MatBottomSheetModule
                }]
              }], function () {
                return [{
                  type: i3.Overlay
                }, {
                  type: i0.Injector
                }, {
                  type: MatBottomSheet,
                  decorators: [{
                    type: Optional
                  }, {
                    type: SkipSelf
                  }]
                }, {
                  type: MatBottomSheetConfig,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_BOTTOM_SHEET_DEFAULT_OPTIONS]
                  }]
                }];
              }, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-bottom-sheet.js.map
