/* esm-bundle - @angular/material/legacy-card@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/platform-browser/animations', '@angular/material/core'], (function (exports) {
    'use strict';
    var i0, Directive, Input, Component, ViewEncapsulation, ChangeDetectionStrategy, Optional, Inject, NgModule, ANIMATION_MODULE_TYPE, MatCommonModule;
    return {
        setters: [function (module) {
            i0 = module;
            Directive = module.Directive;
            Input = module.Input;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            Optional = module.Optional;
            Inject = module.Inject;
            NgModule = module.NgModule;
        }, function (module) {
            ANIMATION_MODULE_TYPE = module.ANIMATION_MODULE_TYPE;
        }, function (module) {
            MatCommonModule = module.MatCommonModule;
        }],
        execute: (function () {

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Content of a card, needed as it's used as a selector in the API.
             * @docs-private
             * @deprecated Use `MatCardContent` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            const _c0 = ["*", [["mat-card-footer"]]];
            const _c1 = ["*", "mat-card-footer"];
            const _c2 = [[["", "mat-card-avatar", ""], ["", "matCardAvatar", ""]], [["mat-card-title"], ["mat-card-subtitle"], ["", "mat-card-title", ""], ["", "mat-card-subtitle", ""], ["", "matCardTitle", ""], ["", "matCardSubtitle", ""]], "*"];
            const _c3 = ["[mat-card-avatar], [matCardAvatar]", "mat-card-title, mat-card-subtitle,\n      [mat-card-title], [mat-card-subtitle],\n      [matCardTitle], [matCardSubtitle]", "*"];
            const _c4 = [[["mat-card-title"], ["mat-card-subtitle"], ["", "mat-card-title", ""], ["", "mat-card-subtitle", ""], ["", "matCardTitle", ""], ["", "matCardSubtitle", ""]], [["img"]], "*"];
            const _c5 = ["mat-card-title, mat-card-subtitle,\n      [mat-card-title], [mat-card-subtitle],\n      [matCardTitle], [matCardSubtitle]", "img", "*"];
            class MatLegacyCardContent {} exports('MatLegacyCardContent', MatLegacyCardContent);
            MatLegacyCardContent.ɵfac = function MatLegacyCardContent_Factory(t) {
              return new (t || MatLegacyCardContent)();
            };
            MatLegacyCardContent.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardContent,
              selectors: [["mat-card-content"], ["", "mat-card-content", ""], ["", "matCardContent", ""]],
              hostAttrs: [1, "mat-card-content"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardContent, [{
                type: Directive,
                args: [{
                  selector: 'mat-card-content, [mat-card-content], [matCardContent]',
                  host: {
                    'class': 'mat-card-content'
                  }
                }]
              }], null, null);
            })();
            /**
             * Title of a card, needed as it's used as a selector in the API.
             * @docs-private
             * @deprecated Use `MatCardTitle` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardTitle {} exports('MatLegacyCardTitle', MatLegacyCardTitle);
            MatLegacyCardTitle.ɵfac = function MatLegacyCardTitle_Factory(t) {
              return new (t || MatLegacyCardTitle)();
            };
            MatLegacyCardTitle.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardTitle,
              selectors: [["mat-card-title"], ["", "mat-card-title", ""], ["", "matCardTitle", ""]],
              hostAttrs: [1, "mat-card-title"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardTitle, [{
                type: Directive,
                args: [{
                  selector: `mat-card-title, [mat-card-title], [matCardTitle]`,
                  host: {
                    'class': 'mat-card-title'
                  }
                }]
              }], null, null);
            })();
            /**
             * Sub-title of a card, needed as it's used as a selector in the API.
             * @docs-private
             * @deprecated Use `MatCardSubtitle` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardSubtitle {} exports('MatLegacyCardSubtitle', MatLegacyCardSubtitle);
            MatLegacyCardSubtitle.ɵfac = function MatLegacyCardSubtitle_Factory(t) {
              return new (t || MatLegacyCardSubtitle)();
            };
            MatLegacyCardSubtitle.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardSubtitle,
              selectors: [["mat-card-subtitle"], ["", "mat-card-subtitle", ""], ["", "matCardSubtitle", ""]],
              hostAttrs: [1, "mat-card-subtitle"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardSubtitle, [{
                type: Directive,
                args: [{
                  selector: `mat-card-subtitle, [mat-card-subtitle], [matCardSubtitle]`,
                  host: {
                    'class': 'mat-card-subtitle'
                  }
                }]
              }], null, null);
            })();
            /**
             * Action section of a card, needed as it's used as a selector in the API.
             * @docs-private
             * @deprecated Use `MatCardActions` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardActions {
              constructor() {
                /** Position of the actions inside the card. */
                this.align = 'start';
              }
            } exports('MatLegacyCardActions', MatLegacyCardActions);
            MatLegacyCardActions.ɵfac = function MatLegacyCardActions_Factory(t) {
              return new (t || MatLegacyCardActions)();
            };
            MatLegacyCardActions.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardActions,
              selectors: [["mat-card-actions"]],
              hostAttrs: [1, "mat-card-actions"],
              hostVars: 2,
              hostBindings: function MatLegacyCardActions_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵclassProp("mat-card-actions-align-end", ctx.align === "end");
                }
              },
              inputs: {
                align: "align"
              },
              exportAs: ["matCardActions"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardActions, [{
                type: Directive,
                args: [{
                  selector: 'mat-card-actions',
                  exportAs: 'matCardActions',
                  host: {
                    'class': 'mat-card-actions',
                    '[class.mat-card-actions-align-end]': 'align === "end"'
                  }
                }]
              }], null, {
                align: [{
                  type: Input
                }]
              });
            })();
            /**
             * Footer of a card, needed as it's used as a selector in the API.
             * @docs-private
             * @deprecated Use `MatCardFooter` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardFooter {} exports('MatLegacyCardFooter', MatLegacyCardFooter);
            MatLegacyCardFooter.ɵfac = function MatLegacyCardFooter_Factory(t) {
              return new (t || MatLegacyCardFooter)();
            };
            MatLegacyCardFooter.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardFooter,
              selectors: [["mat-card-footer"]],
              hostAttrs: [1, "mat-card-footer"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardFooter, [{
                type: Directive,
                args: [{
                  selector: 'mat-card-footer',
                  host: {
                    'class': 'mat-card-footer'
                  }
                }]
              }], null, null);
            })();
            /**
             * Image used in a card, needed to add the mat- CSS styling.
             * @docs-private
             * @deprecated Use `MatCardImage` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardImage {} exports('MatLegacyCardImage', MatLegacyCardImage);
            MatLegacyCardImage.ɵfac = function MatLegacyCardImage_Factory(t) {
              return new (t || MatLegacyCardImage)();
            };
            MatLegacyCardImage.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardImage,
              selectors: [["", "mat-card-image", ""], ["", "matCardImage", ""]],
              hostAttrs: [1, "mat-card-image"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardImage, [{
                type: Directive,
                args: [{
                  selector: '[mat-card-image], [matCardImage]',
                  host: {
                    'class': 'mat-card-image'
                  }
                }]
              }], null, null);
            })();
            /**
             * Image used in a card, needed to add the mat- CSS styling.
             * @docs-private
             * @deprecated Use `MatCardSmImage` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardSmImage {} exports('MatLegacyCardSmImage', MatLegacyCardSmImage);
            MatLegacyCardSmImage.ɵfac = function MatLegacyCardSmImage_Factory(t) {
              return new (t || MatLegacyCardSmImage)();
            };
            MatLegacyCardSmImage.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardSmImage,
              selectors: [["", "mat-card-sm-image", ""], ["", "matCardImageSmall", ""]],
              hostAttrs: [1, "mat-card-sm-image"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardSmImage, [{
                type: Directive,
                args: [{
                  selector: '[mat-card-sm-image], [matCardImageSmall]',
                  host: {
                    'class': 'mat-card-sm-image'
                  }
                }]
              }], null, null);
            })();
            /**
             * Image used in a card, needed to add the mat- CSS styling.
             * @docs-private
             * @deprecated Use `MatCardMdImage` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardMdImage {} exports('MatLegacyCardMdImage', MatLegacyCardMdImage);
            MatLegacyCardMdImage.ɵfac = function MatLegacyCardMdImage_Factory(t) {
              return new (t || MatLegacyCardMdImage)();
            };
            MatLegacyCardMdImage.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardMdImage,
              selectors: [["", "mat-card-md-image", ""], ["", "matCardImageMedium", ""]],
              hostAttrs: [1, "mat-card-md-image"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardMdImage, [{
                type: Directive,
                args: [{
                  selector: '[mat-card-md-image], [matCardImageMedium]',
                  host: {
                    'class': 'mat-card-md-image'
                  }
                }]
              }], null, null);
            })();
            /**
             * Image used in a card, needed to add the mat- CSS styling.
             * @docs-private
             * @deprecated Use `MatCardLgImage` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardLgImage {} exports('MatLegacyCardLgImage', MatLegacyCardLgImage);
            MatLegacyCardLgImage.ɵfac = function MatLegacyCardLgImage_Factory(t) {
              return new (t || MatLegacyCardLgImage)();
            };
            MatLegacyCardLgImage.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardLgImage,
              selectors: [["", "mat-card-lg-image", ""], ["", "matCardImageLarge", ""]],
              hostAttrs: [1, "mat-card-lg-image"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardLgImage, [{
                type: Directive,
                args: [{
                  selector: '[mat-card-lg-image], [matCardImageLarge]',
                  host: {
                    'class': 'mat-card-lg-image'
                  }
                }]
              }], null, null);
            })();
            /**
             * Large image used in a card, needed to add the mat- CSS styling.
             * @docs-private
             * @deprecated Use `MatCardXlImage` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardXlImage {} exports('MatLegacyCardXlImage', MatLegacyCardXlImage);
            MatLegacyCardXlImage.ɵfac = function MatLegacyCardXlImage_Factory(t) {
              return new (t || MatLegacyCardXlImage)();
            };
            MatLegacyCardXlImage.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardXlImage,
              selectors: [["", "mat-card-xl-image", ""], ["", "matCardImageXLarge", ""]],
              hostAttrs: [1, "mat-card-xl-image"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardXlImage, [{
                type: Directive,
                args: [{
                  selector: '[mat-card-xl-image], [matCardImageXLarge]',
                  host: {
                    'class': 'mat-card-xl-image'
                  }
                }]
              }], null, null);
            })();
            /**
             * Avatar image used in a card, needed to add the mat- CSS styling.
             * @docs-private
             * @deprecated Use `MatCardAvatar` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardAvatar {} exports('MatLegacyCardAvatar', MatLegacyCardAvatar);
            MatLegacyCardAvatar.ɵfac = function MatLegacyCardAvatar_Factory(t) {
              return new (t || MatLegacyCardAvatar)();
            };
            MatLegacyCardAvatar.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyCardAvatar,
              selectors: [["", "mat-card-avatar", ""], ["", "matCardAvatar", ""]],
              hostAttrs: [1, "mat-card-avatar"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardAvatar, [{
                type: Directive,
                args: [{
                  selector: '[mat-card-avatar], [matCardAvatar]',
                  host: {
                    'class': 'mat-card-avatar'
                  }
                }]
              }], null, null);
            })();
            /**
             * A basic content container component that adds the styles of a Material design card.
             *
             * While this component can be used alone, it also provides a number
             * of preset styles for common card sections, including:
             * - mat-card-title
             * - mat-card-subtitle
             * - mat-card-content
             * - mat-card-actions
             * - mat-card-footer
             *
             * @deprecated Use `MatCard` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCard {
              // @breaking-change 9.0.0 `_animationMode` parameter to be made required.
              constructor(_animationMode) {
                this._animationMode = _animationMode;
              }
            } exports('MatLegacyCard', MatLegacyCard);
            MatLegacyCard.ɵfac = function MatLegacyCard_Factory(t) {
              return new (t || MatLegacyCard)(i0.ɵɵdirectiveInject(ANIMATION_MODULE_TYPE, 8));
            };
            MatLegacyCard.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyCard,
              selectors: [["mat-card"]],
              hostAttrs: [1, "mat-card", "mat-focus-indicator"],
              hostVars: 2,
              hostBindings: function MatLegacyCard_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵclassProp("_mat-animation-noopable", ctx._animationMode === "NoopAnimations");
                }
              },
              exportAs: ["matCard"],
              ngContentSelectors: _c1,
              decls: 2,
              vars: 0,
              template: function MatLegacyCard_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef(_c0);
                  i0.ɵɵprojection(0);
                  i0.ɵɵprojection(1, 1);
                }
              },
              styles: [".mat-card{transition:box-shadow 280ms cubic-bezier(0.4, 0, 0.2, 1);display:block;position:relative;padding:16px;border-radius:4px}.mat-card._mat-animation-noopable{transition:none !important;animation:none !important}.mat-card>.mat-divider-horizontal{position:absolute;left:0;width:100%}[dir=rtl] .mat-card>.mat-divider-horizontal{left:auto;right:0}.mat-card>.mat-divider-horizontal.mat-divider-inset{position:static;margin:0}[dir=rtl] .mat-card>.mat-divider-horizontal.mat-divider-inset{margin-right:0}.cdk-high-contrast-active .mat-card{outline:solid 1px}.mat-card-actions,.mat-card-subtitle,.mat-card-content{display:block;margin-bottom:16px}.mat-card-title{display:block;margin-bottom:8px}.mat-card-actions{margin-left:-8px;margin-right:-8px;padding:8px 0}.mat-card-actions-align-end{display:flex;justify-content:flex-end}.mat-card-image{width:calc(100% + 32px);margin:0 -16px 16px -16px;display:block;overflow:hidden}.mat-card-image img{width:100%}.mat-card-footer{display:block;margin:0 -16px -16px -16px}.mat-card-actions .mat-button,.mat-card-actions .mat-raised-button,.mat-card-actions .mat-stroked-button{margin:0 8px}.mat-card-header{display:flex;flex-direction:row}.mat-card-header .mat-card-title{margin-bottom:12px}.mat-card-header-text{margin:0 16px}.mat-card-avatar{height:40px;width:40px;border-radius:50%;flex-shrink:0;object-fit:cover}.mat-card-title-group{display:flex;justify-content:space-between}.mat-card-sm-image{width:80px;height:80px}.mat-card-md-image{width:112px;height:112px}.mat-card-lg-image{width:152px;height:152px}.mat-card-xl-image{width:240px;height:240px;margin:-8px}.mat-card-title-group>.mat-card-xl-image{margin:-8px 0 8px}@media(max-width: 599px){.mat-card-title-group{margin:0}.mat-card-xl-image{margin-left:0;margin-right:0}}.mat-card>:first-child,.mat-card-content>:first-child{margin-top:0}.mat-card>:last-child:not(.mat-card-footer),.mat-card-content>:last-child:not(.mat-card-footer){margin-bottom:0}.mat-card-image:first-child{margin-top:-16px;border-top-left-radius:inherit;border-top-right-radius:inherit}.mat-card>.mat-card-actions:last-child{margin-bottom:-8px;padding-bottom:0}.mat-card-actions:not(.mat-card-actions-align-end) .mat-button:first-child,.mat-card-actions:not(.mat-card-actions-align-end) .mat-raised-button:first-child,.mat-card-actions:not(.mat-card-actions-align-end) .mat-stroked-button:first-child{margin-left:0;margin-right:0}.mat-card-actions-align-end .mat-button:last-child,.mat-card-actions-align-end .mat-raised-button:last-child,.mat-card-actions-align-end .mat-stroked-button:last-child{margin-left:0;margin-right:0}.mat-card-title:not(:first-child),.mat-card-subtitle:not(:first-child){margin-top:-4px}.mat-card-header .mat-card-subtitle:not(:first-child){margin-top:-8px}.mat-card>.mat-card-xl-image:first-child{margin-top:-8px}.mat-card>.mat-card-xl-image:last-child{margin-bottom:-8px}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCard, [{
                type: Component,
                args: [{
                  selector: 'mat-card',
                  exportAs: 'matCard',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  host: {
                    'class': 'mat-card mat-focus-indicator',
                    '[class._mat-animation-noopable]': '_animationMode === "NoopAnimations"'
                  },
                  template: "<ng-content></ng-content>\n<ng-content select=\"mat-card-footer\"></ng-content>\n",
                  styles: [".mat-card{transition:box-shadow 280ms cubic-bezier(0.4, 0, 0.2, 1);display:block;position:relative;padding:16px;border-radius:4px}.mat-card._mat-animation-noopable{transition:none !important;animation:none !important}.mat-card>.mat-divider-horizontal{position:absolute;left:0;width:100%}[dir=rtl] .mat-card>.mat-divider-horizontal{left:auto;right:0}.mat-card>.mat-divider-horizontal.mat-divider-inset{position:static;margin:0}[dir=rtl] .mat-card>.mat-divider-horizontal.mat-divider-inset{margin-right:0}.cdk-high-contrast-active .mat-card{outline:solid 1px}.mat-card-actions,.mat-card-subtitle,.mat-card-content{display:block;margin-bottom:16px}.mat-card-title{display:block;margin-bottom:8px}.mat-card-actions{margin-left:-8px;margin-right:-8px;padding:8px 0}.mat-card-actions-align-end{display:flex;justify-content:flex-end}.mat-card-image{width:calc(100% + 32px);margin:0 -16px 16px -16px;display:block;overflow:hidden}.mat-card-image img{width:100%}.mat-card-footer{display:block;margin:0 -16px -16px -16px}.mat-card-actions .mat-button,.mat-card-actions .mat-raised-button,.mat-card-actions .mat-stroked-button{margin:0 8px}.mat-card-header{display:flex;flex-direction:row}.mat-card-header .mat-card-title{margin-bottom:12px}.mat-card-header-text{margin:0 16px}.mat-card-avatar{height:40px;width:40px;border-radius:50%;flex-shrink:0;object-fit:cover}.mat-card-title-group{display:flex;justify-content:space-between}.mat-card-sm-image{width:80px;height:80px}.mat-card-md-image{width:112px;height:112px}.mat-card-lg-image{width:152px;height:152px}.mat-card-xl-image{width:240px;height:240px;margin:-8px}.mat-card-title-group>.mat-card-xl-image{margin:-8px 0 8px}@media(max-width: 599px){.mat-card-title-group{margin:0}.mat-card-xl-image{margin-left:0;margin-right:0}}.mat-card>:first-child,.mat-card-content>:first-child{margin-top:0}.mat-card>:last-child:not(.mat-card-footer),.mat-card-content>:last-child:not(.mat-card-footer){margin-bottom:0}.mat-card-image:first-child{margin-top:-16px;border-top-left-radius:inherit;border-top-right-radius:inherit}.mat-card>.mat-card-actions:last-child{margin-bottom:-8px;padding-bottom:0}.mat-card-actions:not(.mat-card-actions-align-end) .mat-button:first-child,.mat-card-actions:not(.mat-card-actions-align-end) .mat-raised-button:first-child,.mat-card-actions:not(.mat-card-actions-align-end) .mat-stroked-button:first-child{margin-left:0;margin-right:0}.mat-card-actions-align-end .mat-button:last-child,.mat-card-actions-align-end .mat-raised-button:last-child,.mat-card-actions-align-end .mat-stroked-button:last-child{margin-left:0;margin-right:0}.mat-card-title:not(:first-child),.mat-card-subtitle:not(:first-child){margin-top:-4px}.mat-card-header .mat-card-subtitle:not(:first-child){margin-top:-8px}.mat-card>.mat-card-xl-image:first-child{margin-top:-8px}.mat-card>.mat-card-xl-image:last-child{margin-bottom:-8px}"]
                }]
              }], function () {
                return [{
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }];
              }, null);
            })();
            /**
             * Component intended to be used within the `<mat-card>` component. It adds styles for a
             * preset header section (i.e. a title, subtitle, and avatar layout).
             * @docs-private
             * @deprecated Use `MatCardHeader` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardHeader {} exports('MatLegacyCardHeader', MatLegacyCardHeader);
            MatLegacyCardHeader.ɵfac = function MatLegacyCardHeader_Factory(t) {
              return new (t || MatLegacyCardHeader)();
            };
            MatLegacyCardHeader.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyCardHeader,
              selectors: [["mat-card-header"]],
              hostAttrs: [1, "mat-card-header"],
              ngContentSelectors: _c3,
              decls: 4,
              vars: 0,
              consts: [[1, "mat-card-header-text"]],
              template: function MatLegacyCardHeader_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef(_c2);
                  i0.ɵɵprojection(0);
                  i0.ɵɵelementStart(1, "div", 0);
                  i0.ɵɵprojection(2, 1);
                  i0.ɵɵelementEnd();
                  i0.ɵɵprojection(3, 2);
                }
              },
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardHeader, [{
                type: Component,
                args: [{
                  selector: 'mat-card-header',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  host: {
                    'class': 'mat-card-header'
                  },
                  template: "<ng-content select=\"[mat-card-avatar], [matCardAvatar]\"></ng-content>\n<div class=\"mat-card-header-text\">\n  <ng-content\n      select=\"mat-card-title, mat-card-subtitle,\n      [mat-card-title], [mat-card-subtitle],\n      [matCardTitle], [matCardSubtitle]\"></ng-content>\n</div>\n<ng-content></ng-content>\n"
                }]
              }], null, null);
            })();
            /**
             * Component intended to be used within the `<mat-card>` component. It adds styles for a preset
             * layout that groups an image with a title section.
             * @docs-private
             * @deprecated Use `MatCardTitleGroup` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardTitleGroup {} exports('MatLegacyCardTitleGroup', MatLegacyCardTitleGroup);
            MatLegacyCardTitleGroup.ɵfac = function MatLegacyCardTitleGroup_Factory(t) {
              return new (t || MatLegacyCardTitleGroup)();
            };
            MatLegacyCardTitleGroup.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyCardTitleGroup,
              selectors: [["mat-card-title-group"]],
              hostAttrs: [1, "mat-card-title-group"],
              ngContentSelectors: _c5,
              decls: 4,
              vars: 0,
              template: function MatLegacyCardTitleGroup_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef(_c4);
                  i0.ɵɵelementStart(0, "div");
                  i0.ɵɵprojection(1);
                  i0.ɵɵelementEnd();
                  i0.ɵɵprojection(2, 1);
                  i0.ɵɵprojection(3, 2);
                }
              },
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardTitleGroup, [{
                type: Component,
                args: [{
                  selector: 'mat-card-title-group',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  host: {
                    'class': 'mat-card-title-group'
                  },
                  template: "<div>\n  <ng-content\n      select=\"mat-card-title, mat-card-subtitle,\n      [mat-card-title], [mat-card-subtitle],\n      [matCardTitle], [matCardSubtitle]\"></ng-content>\n</div>\n<ng-content select=\"img\"></ng-content>\n<ng-content></ng-content>\n"
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatCardModule` from `@angular/material/card` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyCardModule {} exports('MatLegacyCardModule', MatLegacyCardModule);
            MatLegacyCardModule.ɵfac = function MatLegacyCardModule_Factory(t) {
              return new (t || MatLegacyCardModule)();
            };
            MatLegacyCardModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatLegacyCardModule
            });
            MatLegacyCardModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              imports: [MatCommonModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyCardModule, [{
                type: NgModule,
                args: [{
                  imports: [MatCommonModule],
                  exports: [MatLegacyCard, MatLegacyCardHeader, MatLegacyCardTitleGroup, MatLegacyCardContent, MatLegacyCardTitle, MatLegacyCardSubtitle, MatLegacyCardActions, MatLegacyCardFooter, MatLegacyCardSmImage, MatLegacyCardMdImage, MatLegacyCardLgImage, MatLegacyCardImage, MatLegacyCardXlImage, MatLegacyCardAvatar, MatCommonModule],
                  declarations: [MatLegacyCard, MatLegacyCardHeader, MatLegacyCardTitleGroup, MatLegacyCardContent, MatLegacyCardTitle, MatLegacyCardSubtitle, MatLegacyCardActions, MatLegacyCardFooter, MatLegacyCardSmImage, MatLegacyCardMdImage, MatLegacyCardLgImage, MatLegacyCardImage, MatLegacyCardXlImage, MatLegacyCardAvatar]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-legacy-card.js.map
