/* esm-bundle - @angular/material/legacy-input@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/material/input', '@angular/material/legacy-form-field', '@angular/cdk/text-field', '@angular/material/core'], (function (exports) {
    'use strict';
    var i0, Directive, NgModule, inject, MatInput, MatLegacyFormFieldControl, MatLegacyFormFieldModule, MAT_LEGACY_FORM_FIELD, TextFieldModule, ErrorStateMatcher, MatCommonModule;
    return {
        setters: [function (module) {
            i0 = module;
            Directive = module.Directive;
            NgModule = module.NgModule;
            inject = module.inject;
        }, function (module) {
            MatInput = module.MatInput;
            exports({ MAT_LEGACY_INPUT_VALUE_ACCESSOR: module.MAT_INPUT_VALUE_ACCESSOR, getMatLegacyInputUnsupportedTypeError: module.getMatInputUnsupportedTypeError });
        }, function (module) {
            MatLegacyFormFieldControl = module.MatLegacyFormFieldControl;
            MatLegacyFormFieldModule = module.MatLegacyFormFieldModule;
            MAT_LEGACY_FORM_FIELD = module.MAT_LEGACY_FORM_FIELD;
        }, function (module) {
            TextFieldModule = module.TextFieldModule;
        }, function (module) {
            ErrorStateMatcher = module.ErrorStateMatcher;
            MatCommonModule = module.MatCommonModule;
        }],
        execute: (function () {

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Directive that allows a native input to work inside a `MatFormField`.
             * @deprecated Use `MatInput` from `@angular/material/input` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyInput extends MatInput {
              constructor() {
                super(...arguments);
                this._legacyFormField = inject(MAT_LEGACY_FORM_FIELD, {
                  optional: true
                });
              }
              _getPlaceholder() {
                var _a;
                // If we're hiding the native placeholder, it should also be cleared from the DOM, otherwise
                // screen readers will read it out twice: once from the label and once from the attribute.
                // TODO: can be removed once we get rid of the `legacy` style for the form field, because it's
                // the only one that supports promoting the placeholder to a label.
                const formField = this._legacyFormField;
                return formField && formField.appearance === 'legacy' && !((_a = formField._hasLabel) === null || _a === void 0 ? void 0 : _a.call(formField)) ? null : this.placeholder;
              }
            } exports('MatLegacyInput', MatLegacyInput);
            MatLegacyInput.ɵfac = /* @__PURE__ */function () {
              let ɵMatLegacyInput_BaseFactory;
              return function MatLegacyInput_Factory(t) {
                return (ɵMatLegacyInput_BaseFactory || (ɵMatLegacyInput_BaseFactory = i0.ɵɵgetInheritedFactory(MatLegacyInput)))(t || MatLegacyInput);
              };
            }();
            MatLegacyInput.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatLegacyInput,
              selectors: [["input", "matInput", ""], ["textarea", "matInput", ""], ["select", "matNativeControl", ""], ["input", "matNativeControl", ""], ["textarea", "matNativeControl", ""]],
              hostAttrs: [1, "mat-input-element", "mat-form-field-autofill-control"],
              hostVars: 15,
              hostBindings: function MatLegacyInput_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵattribute("data-placeholder", ctx.placeholder);
                  i0.ɵɵclassProp("mat-input-server", ctx._isServer)("mat-mdc-input-element", false)("mat-mdc-form-field-textarea-control", false)("mat-mdc-form-field-input-control", false)("mdc-text-field__input", false)("mat-mdc-native-select-inline", false)("mat-native-select-inline", ctx._isInlineSelect());
                }
              },
              exportAs: ["matInput"],
              features: [i0.ɵɵProvidersFeature([{
                provide: MatLegacyFormFieldControl,
                useExisting: MatLegacyInput
              }]), i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyInput, [{
                type: Directive,
                args: [{
                  selector: `input[matInput], textarea[matInput], select[matNativeControl],
      input[matNativeControl], textarea[matNativeControl]`,
                  exportAs: 'matInput',
                  host: {
                    /**
                     * @breaking-change 8.0.0 remove .mat-form-field-autofill-control in favor of AutofillMonitor.
                     */
                    'class': 'mat-input-element mat-form-field-autofill-control',
                    '[class.mat-input-server]': '_isServer',
                    // These classes are inherited from the base input class and need to be cleared.
                    '[class.mat-mdc-input-element]': 'false',
                    '[class.mat-mdc-form-field-textarea-control]': 'false',
                    '[class.mat-mdc-form-field-input-control]': 'false',
                    '[class.mdc-text-field__input]': 'false',
                    '[class.mat-mdc-native-select-inline]': 'false',
                    // At the time of writing, we have a lot of customer tests that look up the input based on its
                    // placeholder. Since we sometimes omit the placeholder attribute from the DOM to prevent screen
                    // readers from reading it twice, we have to keep it somewhere in the DOM for the lookup.
                    '[attr.data-placeholder]': 'placeholder',
                    '[class.mat-native-select-inline]': '_isInlineSelect()'
                  },
                  providers: [{
                    provide: MatLegacyFormFieldControl,
                    useExisting: MatLegacyInput
                  }]
                }]
              }], null, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatInputModule` from `@angular/material/input` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyInputModule {} exports('MatLegacyInputModule', MatLegacyInputModule);
            MatLegacyInputModule.ɵfac = function MatLegacyInputModule_Factory(t) {
              return new (t || MatLegacyInputModule)();
            };
            MatLegacyInputModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatLegacyInputModule
            });
            MatLegacyInputModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [ErrorStateMatcher],
              imports: [TextFieldModule, MatLegacyFormFieldModule, MatCommonModule, TextFieldModule,
              // We re-export the `MatLegacyFormFieldModule` since `MatLegacyInput` will almost always
              // be used together with `MatLegacyFormField`.
              MatLegacyFormFieldModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyInputModule, [{
                type: NgModule,
                args: [{
                  declarations: [MatLegacyInput],
                  imports: [TextFieldModule, MatLegacyFormFieldModule, MatCommonModule],
                  exports: [TextFieldModule,
                  // We re-export the `MatLegacyFormFieldModule` since `MatLegacyInput` will almost always
                  // be used together with `MatLegacyFormField`.
                  MatLegacyFormFieldModule, MatLegacyInput],
                  providers: [ErrorStateMatcher]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-legacy-input.js.map
