/* esm-bundle - @angular/material/tooltip@15.2.9 - Ivy - system format - es2015 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['rxjs/operators', '@angular/cdk/coercion', '@angular/cdk/keycodes', '@angular/core', '@angular/common', '@angular/cdk/platform', '@angular/platform-browser/animations', '@angular/cdk/overlay', '@angular/cdk/portal', 'rxjs', '@angular/cdk/a11y', '@angular/cdk/bidi', '@angular/animations', '@angular/cdk/scrolling', '@angular/material/core'], (function (exports) {
    'use strict';
    var takeUntil, take, coerceBooleanProperty, coerceNumberProperty, ESCAPE, hasModifierKey, InjectionToken, i0, Directive, Inject, Input, Optional, Component, ViewEncapsulation, ChangeDetectionStrategy, ViewChild, NgModule, ElementRef, DOCUMENT, i5, CommonModule, normalizePassiveListenerOptions, i2, ANIMATION_MODULE_TYPE, i1, OverlayModule, Overlay, ComponentPortal, Subject, i3, A11yModule, i4, trigger, state, style, transition, animate, CdkScrollableModule, MatCommonModule;
    return {
        setters: [function (module) {
            takeUntil = module.takeUntil;
            take = module.take;
        }, function (module) {
            coerceBooleanProperty = module.coerceBooleanProperty;
            coerceNumberProperty = module.coerceNumberProperty;
        }, function (module) {
            ESCAPE = module.ESCAPE;
            hasModifierKey = module.hasModifierKey;
        }, function (module) {
            InjectionToken = module.InjectionToken;
            i0 = module;
            Directive = module.Directive;
            Inject = module.Inject;
            Input = module.Input;
            Optional = module.Optional;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ViewChild = module.ViewChild;
            NgModule = module.NgModule;
            ElementRef = module.ElementRef;
        }, function (module) {
            DOCUMENT = module.DOCUMENT;
            i5 = module;
            CommonModule = module.CommonModule;
        }, function (module) {
            normalizePassiveListenerOptions = module.normalizePassiveListenerOptions;
            i2 = module;
        }, function (module) {
            ANIMATION_MODULE_TYPE = module.ANIMATION_MODULE_TYPE;
        }, function (module) {
            i1 = module;
            OverlayModule = module.OverlayModule;
            Overlay = module.Overlay;
        }, function (module) {
            ComponentPortal = module.ComponentPortal;
        }, function (module) {
            Subject = module.Subject;
        }, function (module) {
            i3 = module;
            A11yModule = module.A11yModule;
        }, function (module) {
            i4 = module;
        }, function (module) {
            trigger = module.trigger;
            state = module.state;
            style = module.style;
            transition = module.transition;
            animate = module.animate;
        }, function (module) {
            CdkScrollableModule = module.CdkScrollableModule;
        }, function (module) {
            MatCommonModule = module.MatCommonModule;
        }],
        execute: (function () {

            exports({
                MAT_TOOLTIP_DEFAULT_OPTIONS_FACTORY: MAT_TOOLTIP_DEFAULT_OPTIONS_FACTORY,
                MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY: MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY,
                getMatTooltipInvalidPositionError: getMatTooltipInvalidPositionError
            });

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /** Time in ms to throttle repositioning after scroll events. */
            const _c0 = ["tooltip"];
            const SCROLL_THROTTLE_MS = exports('SCROLL_THROTTLE_MS', 20);
            /**
             * Creates an error to be thrown if the user supplied an invalid tooltip position.
             * @docs-private
             */
            function getMatTooltipInvalidPositionError(position) {
              return Error(`Tooltip position "${position}" is invalid.`);
            }
            /** Injection token that determines the scroll handling while a tooltip is visible. */
            const MAT_TOOLTIP_SCROLL_STRATEGY = exports('MAT_TOOLTIP_SCROLL_STRATEGY', new InjectionToken('mat-tooltip-scroll-strategy'));
            /** @docs-private */
            function MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY(overlay) {
              return () => overlay.scrollStrategies.reposition({
                scrollThrottle: SCROLL_THROTTLE_MS
              });
            }
            /** @docs-private */
            const MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER = exports('MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER', {
              provide: MAT_TOOLTIP_SCROLL_STRATEGY,
              deps: [Overlay],
              useFactory: MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY
            });
            /** @docs-private */
            function MAT_TOOLTIP_DEFAULT_OPTIONS_FACTORY() {
              return {
                showDelay: 0,
                hideDelay: 0,
                touchendHideDelay: 1500
              };
            }
            /** Injection token to be used to override the default options for `matTooltip`. */
            const MAT_TOOLTIP_DEFAULT_OPTIONS = exports('MAT_TOOLTIP_DEFAULT_OPTIONS', new InjectionToken('mat-tooltip-default-options', {
              providedIn: 'root',
              factory: MAT_TOOLTIP_DEFAULT_OPTIONS_FACTORY
            }));
            /**
             * CSS class that will be attached to the overlay panel.
             * @deprecated
             * @breaking-change 13.0.0 remove this variable
             */
            const TOOLTIP_PANEL_CLASS = exports('TOOLTIP_PANEL_CLASS', 'mat-mdc-tooltip-panel');
            const PANEL_CLASS = 'tooltip-panel';
            /** Options used to bind passive event listeners. */
            const passiveListenerOptions = normalizePassiveListenerOptions({
              passive: true
            });
            /**
             * Time between the user putting the pointer on a tooltip
             * trigger and the long press event being fired.
             */
            const LONGPRESS_DELAY = 500;
            // These constants were taken from MDC's `numbers` object. We can't import them from MDC,
            // because they have some top-level references to `window` which break during SSR.
            const MIN_VIEWPORT_TOOLTIP_THRESHOLD = 8;
            const UNBOUNDED_ANCHOR_GAP = 8;
            const MIN_HEIGHT = 24;
            const MAX_WIDTH = 200;
            class _MatTooltipBase {
              /** Allows the user to define the position of the tooltip relative to the parent element */
              get position() {
                return this._position;
              }
              set position(value) {
                var _a;
                if (value !== this._position) {
                  this._position = value;
                  if (this._overlayRef) {
                    this._updatePosition(this._overlayRef);
                    (_a = this._tooltipInstance) === null || _a === void 0 ? void 0 : _a.show(0);
                    this._overlayRef.updatePosition();
                  }
                }
              }
              get positionAtOrigin() {
                return this._positionAtOrigin;
              }
              set positionAtOrigin(value) {
                this._positionAtOrigin = coerceBooleanProperty(value);
                this._detach();
                this._overlayRef = null;
              }
              /** Disables the display of the tooltip. */
              get disabled() {
                return this._disabled;
              }
              set disabled(value) {
                this._disabled = coerceBooleanProperty(value);
                // If tooltip is disabled, hide immediately.
                if (this._disabled) {
                  this.hide(0);
                } else {
                  this._setupPointerEnterEventsIfNeeded();
                }
              }
              /** The default delay in ms before showing the tooltip after show is called */
              get showDelay() {
                return this._showDelay;
              }
              set showDelay(value) {
                this._showDelay = coerceNumberProperty(value);
              }
              /** The default delay in ms before hiding the tooltip after hide is called */
              get hideDelay() {
                return this._hideDelay;
              }
              set hideDelay(value) {
                this._hideDelay = coerceNumberProperty(value);
                if (this._tooltipInstance) {
                  this._tooltipInstance._mouseLeaveHideDelay = this._hideDelay;
                }
              }
              /** The message to be displayed in the tooltip */
              get message() {
                return this._message;
              }
              set message(value) {
                this._ariaDescriber.removeDescription(this._elementRef.nativeElement, this._message, 'tooltip');
                // If the message is not a string (e.g. number), convert it to a string and trim it.
                // Must convert with `String(value)`, not `${value}`, otherwise Closure Compiler optimises
                // away the string-conversion: https://github.com/angular/components/issues/20684
                this._message = value != null ? String(value).trim() : '';
                if (!this._message && this._isTooltipVisible()) {
                  this.hide(0);
                } else {
                  this._setupPointerEnterEventsIfNeeded();
                  this._updateTooltipMessage();
                  this._ngZone.runOutsideAngular(() => {
                    // The `AriaDescriber` has some functionality that avoids adding a description if it's the
                    // same as the `aria-label` of an element, however we can't know whether the tooltip trigger
                    // has a data-bound `aria-label` or when it'll be set for the first time. We can avoid the
                    // issue by deferring the description by a tick so Angular has time to set the `aria-label`.
                    Promise.resolve().then(() => {
                      this._ariaDescriber.describe(this._elementRef.nativeElement, this.message, 'tooltip');
                    });
                  });
                }
              }
              /** Classes to be passed to the tooltip. Supports the same syntax as `ngClass`. */
              get tooltipClass() {
                return this._tooltipClass;
              }
              set tooltipClass(value) {
                this._tooltipClass = value;
                if (this._tooltipInstance) {
                  this._setTooltipClass(this._tooltipClass);
                }
              }
              constructor(_overlay, _elementRef, _scrollDispatcher, _viewContainerRef, _ngZone, _platform, _ariaDescriber, _focusMonitor, scrollStrategy, _dir, _defaultOptions, _document) {
                this._overlay = _overlay;
                this._elementRef = _elementRef;
                this._scrollDispatcher = _scrollDispatcher;
                this._viewContainerRef = _viewContainerRef;
                this._ngZone = _ngZone;
                this._platform = _platform;
                this._ariaDescriber = _ariaDescriber;
                this._focusMonitor = _focusMonitor;
                this._dir = _dir;
                this._defaultOptions = _defaultOptions;
                this._position = 'below';
                this._positionAtOrigin = false;
                this._disabled = false;
                this._viewInitialized = false;
                this._pointerExitEventsInitialized = false;
                this._viewportMargin = 8;
                this._cssClassPrefix = 'mat';
                this._showDelay = this._defaultOptions.showDelay;
                this._hideDelay = this._defaultOptions.hideDelay;
                /**
                 * How touch gestures should be handled by the tooltip. On touch devices the tooltip directive
                 * uses a long press gesture to show and hide, however it can conflict with the native browser
                 * gestures. To work around the conflict, Angular Material disables native gestures on the
                 * trigger, but that might not be desirable on particular elements (e.g. inputs and draggable
                 * elements). The different values for this option configure the touch event handling as follows:
                 * - `auto` - Enables touch gestures for all elements, but tries to avoid conflicts with native
                 *   browser gestures on particular elements. In particular, it allows text selection on inputs
                 *   and textareas, and preserves the native browser dragging on elements marked as `draggable`.
                 * - `on` - Enables touch gestures for all elements and disables native
                 *   browser gestures with no exceptions.
                 * - `off` - Disables touch gestures. Note that this will prevent the tooltip from
                 *   showing on touch devices.
                 */
                this.touchGestures = 'auto';
                this._message = '';
                /** Manually-bound passive event listeners. */
                this._passiveListeners = [];
                /** Emits when the component is destroyed. */
                this._destroyed = new Subject();
                this._scrollStrategy = scrollStrategy;
                this._document = _document;
                if (_defaultOptions) {
                  if (_defaultOptions.position) {
                    this.position = _defaultOptions.position;
                  }
                  if (_defaultOptions.positionAtOrigin) {
                    this.positionAtOrigin = _defaultOptions.positionAtOrigin;
                  }
                  if (_defaultOptions.touchGestures) {
                    this.touchGestures = _defaultOptions.touchGestures;
                  }
                }
                _dir.change.pipe(takeUntil(this._destroyed)).subscribe(() => {
                  if (this._overlayRef) {
                    this._updatePosition(this._overlayRef);
                  }
                });
              }
              ngAfterViewInit() {
                // This needs to happen after view init so the initial values for all inputs have been set.
                this._viewInitialized = true;
                this._setupPointerEnterEventsIfNeeded();
                this._focusMonitor.monitor(this._elementRef).pipe(takeUntil(this._destroyed)).subscribe(origin => {
                  // Note that the focus monitor runs outside the Angular zone.
                  if (!origin) {
                    this._ngZone.run(() => this.hide(0));
                  } else if (origin === 'keyboard') {
                    this._ngZone.run(() => this.show());
                  }
                });
              }
              /**
               * Dispose the tooltip when destroyed.
               */
              ngOnDestroy() {
                const nativeElement = this._elementRef.nativeElement;
                clearTimeout(this._touchstartTimeout);
                if (this._overlayRef) {
                  this._overlayRef.dispose();
                  this._tooltipInstance = null;
                }
                // Clean up the event listeners set in the constructor
                this._passiveListeners.forEach(([event, listener]) => {
                  nativeElement.removeEventListener(event, listener, passiveListenerOptions);
                });
                this._passiveListeners.length = 0;
                this._destroyed.next();
                this._destroyed.complete();
                this._ariaDescriber.removeDescription(nativeElement, this.message, 'tooltip');
                this._focusMonitor.stopMonitoring(nativeElement);
              }
              /** Shows the tooltip after the delay in ms, defaults to tooltip-delay-show or 0ms if no input */
              show(delay = this.showDelay, origin) {
                var _a;
                if (this.disabled || !this.message || this._isTooltipVisible()) {
                  (_a = this._tooltipInstance) === null || _a === void 0 ? void 0 : _a._cancelPendingAnimations();
                  return;
                }
                const overlayRef = this._createOverlay(origin);
                this._detach();
                this._portal = this._portal || new ComponentPortal(this._tooltipComponent, this._viewContainerRef);
                const instance = this._tooltipInstance = overlayRef.attach(this._portal).instance;
                instance._triggerElement = this._elementRef.nativeElement;
                instance._mouseLeaveHideDelay = this._hideDelay;
                instance.afterHidden().pipe(takeUntil(this._destroyed)).subscribe(() => this._detach());
                this._setTooltipClass(this._tooltipClass);
                this._updateTooltipMessage();
                instance.show(delay);
              }
              /** Hides the tooltip after the delay in ms, defaults to tooltip-delay-hide or 0ms if no input */
              hide(delay = this.hideDelay) {
                const instance = this._tooltipInstance;
                if (instance) {
                  if (instance.isVisible()) {
                    instance.hide(delay);
                  } else {
                    instance._cancelPendingAnimations();
                    this._detach();
                  }
                }
              }
              /** Shows/hides the tooltip */
              toggle(origin) {
                this._isTooltipVisible() ? this.hide() : this.show(undefined, origin);
              }
              /** Returns true if the tooltip is currently visible to the user */
              _isTooltipVisible() {
                return !!this._tooltipInstance && this._tooltipInstance.isVisible();
              }
              /** Create the overlay config and position strategy */
              _createOverlay(origin) {
                var _a;
                if (this._overlayRef) {
                  const existingStrategy = this._overlayRef.getConfig().positionStrategy;
                  if ((!this.positionAtOrigin || !origin) && existingStrategy._origin instanceof ElementRef) {
                    return this._overlayRef;
                  }
                  this._detach();
                }
                const scrollableAncestors = this._scrollDispatcher.getAncestorScrollContainers(this._elementRef);
                // Create connected position strategy that listens for scroll events to reposition.
                const strategy = this._overlay.position().flexibleConnectedTo(this.positionAtOrigin ? origin || this._elementRef : this._elementRef).withTransformOriginOn(`.${this._cssClassPrefix}-tooltip`).withFlexibleDimensions(false).withViewportMargin(this._viewportMargin).withScrollableContainers(scrollableAncestors);
                strategy.positionChanges.pipe(takeUntil(this._destroyed)).subscribe(change => {
                  this._updateCurrentPositionClass(change.connectionPair);
                  if (this._tooltipInstance) {
                    if (change.scrollableViewProperties.isOverlayClipped && this._tooltipInstance.isVisible()) {
                      // After position changes occur and the overlay is clipped by
                      // a parent scrollable then close the tooltip.
                      this._ngZone.run(() => this.hide(0));
                    }
                  }
                });
                this._overlayRef = this._overlay.create({
                  direction: this._dir,
                  positionStrategy: strategy,
                  panelClass: `${this._cssClassPrefix}-${PANEL_CLASS}`,
                  scrollStrategy: this._scrollStrategy()
                });
                this._updatePosition(this._overlayRef);
                this._overlayRef.detachments().pipe(takeUntil(this._destroyed)).subscribe(() => this._detach());
                this._overlayRef.outsidePointerEvents().pipe(takeUntil(this._destroyed)).subscribe(() => {
                  var _a;
                  return (_a = this._tooltipInstance) === null || _a === void 0 ? void 0 : _a._handleBodyInteraction();
                });
                this._overlayRef.keydownEvents().pipe(takeUntil(this._destroyed)).subscribe(event => {
                  if (this._isTooltipVisible() && event.keyCode === ESCAPE && !hasModifierKey(event)) {
                    event.preventDefault();
                    event.stopPropagation();
                    this._ngZone.run(() => this.hide(0));
                  }
                });
                if ((_a = this._defaultOptions) === null || _a === void 0 ? void 0 : _a.disableTooltipInteractivity) {
                  this._overlayRef.addPanelClass(`${this._cssClassPrefix}-tooltip-panel-non-interactive`);
                }
                return this._overlayRef;
              }
              /** Detaches the currently-attached tooltip. */
              _detach() {
                if (this._overlayRef && this._overlayRef.hasAttached()) {
                  this._overlayRef.detach();
                }
                this._tooltipInstance = null;
              }
              /** Updates the position of the current tooltip. */
              _updatePosition(overlayRef) {
                const position = overlayRef.getConfig().positionStrategy;
                const origin = this._getOrigin();
                const overlay = this._getOverlayPosition();
                position.withPositions([this._addOffset(Object.assign(Object.assign({}, origin.main), overlay.main)), this._addOffset(Object.assign(Object.assign({}, origin.fallback), overlay.fallback))]);
              }
              /** Adds the configured offset to a position. Used as a hook for child classes. */
              _addOffset(position) {
                return position;
              }
              /**
               * Returns the origin position and a fallback position based on the user's position preference.
               * The fallback position is the inverse of the origin (e.g. `'below' -> 'above'`).
               */
              _getOrigin() {
                const isLtr = !this._dir || this._dir.value == 'ltr';
                const position = this.position;
                let originPosition;
                if (position == 'above' || position == 'below') {
                  originPosition = {
                    originX: 'center',
                    originY: position == 'above' ? 'top' : 'bottom'
                  };
                } else if (position == 'before' || position == 'left' && isLtr || position == 'right' && !isLtr) {
                  originPosition = {
                    originX: 'start',
                    originY: 'center'
                  };
                } else if (position == 'after' || position == 'right' && isLtr || position == 'left' && !isLtr) {
                  originPosition = {
                    originX: 'end',
                    originY: 'center'
                  };
                } else if (typeof ngDevMode === 'undefined' || ngDevMode) {
                  throw getMatTooltipInvalidPositionError(position);
                }
                const {
                  x,
                  y
                } = this._invertPosition(originPosition.originX, originPosition.originY);
                return {
                  main: originPosition,
                  fallback: {
                    originX: x,
                    originY: y
                  }
                };
              }
              /** Returns the overlay position and a fallback position based on the user's preference */
              _getOverlayPosition() {
                const isLtr = !this._dir || this._dir.value == 'ltr';
                const position = this.position;
                let overlayPosition;
                if (position == 'above') {
                  overlayPosition = {
                    overlayX: 'center',
                    overlayY: 'bottom'
                  };
                } else if (position == 'below') {
                  overlayPosition = {
                    overlayX: 'center',
                    overlayY: 'top'
                  };
                } else if (position == 'before' || position == 'left' && isLtr || position == 'right' && !isLtr) {
                  overlayPosition = {
                    overlayX: 'end',
                    overlayY: 'center'
                  };
                } else if (position == 'after' || position == 'right' && isLtr || position == 'left' && !isLtr) {
                  overlayPosition = {
                    overlayX: 'start',
                    overlayY: 'center'
                  };
                } else if (typeof ngDevMode === 'undefined' || ngDevMode) {
                  throw getMatTooltipInvalidPositionError(position);
                }
                const {
                  x,
                  y
                } = this._invertPosition(overlayPosition.overlayX, overlayPosition.overlayY);
                return {
                  main: overlayPosition,
                  fallback: {
                    overlayX: x,
                    overlayY: y
                  }
                };
              }
              /** Updates the tooltip message and repositions the overlay according to the new message length */
              _updateTooltipMessage() {
                // Must wait for the message to be painted to the tooltip so that the overlay can properly
                // calculate the correct positioning based on the size of the text.
                if (this._tooltipInstance) {
                  this._tooltipInstance.message = this.message;
                  this._tooltipInstance._markForCheck();
                  this._ngZone.onMicrotaskEmpty.pipe(take(1), takeUntil(this._destroyed)).subscribe(() => {
                    if (this._tooltipInstance) {
                      this._overlayRef.updatePosition();
                    }
                  });
                }
              }
              /** Updates the tooltip class */
              _setTooltipClass(tooltipClass) {
                if (this._tooltipInstance) {
                  this._tooltipInstance.tooltipClass = tooltipClass;
                  this._tooltipInstance._markForCheck();
                }
              }
              /** Inverts an overlay position. */
              _invertPosition(x, y) {
                if (this.position === 'above' || this.position === 'below') {
                  if (y === 'top') {
                    y = 'bottom';
                  } else if (y === 'bottom') {
                    y = 'top';
                  }
                } else {
                  if (x === 'end') {
                    x = 'start';
                  } else if (x === 'start') {
                    x = 'end';
                  }
                }
                return {
                  x,
                  y
                };
              }
              /** Updates the class on the overlay panel based on the current position of the tooltip. */
              _updateCurrentPositionClass(connectionPair) {
                const {
                  overlayY,
                  originX,
                  originY
                } = connectionPair;
                let newPosition;
                // If the overlay is in the middle along the Y axis,
                // it means that it's either before or after.
                if (overlayY === 'center') {
                  // Note that since this information is used for styling, we want to
                  // resolve `start` and `end` to their real values, otherwise consumers
                  // would have to remember to do it themselves on each consumption.
                  if (this._dir && this._dir.value === 'rtl') {
                    newPosition = originX === 'end' ? 'left' : 'right';
                  } else {
                    newPosition = originX === 'start' ? 'left' : 'right';
                  }
                } else {
                  newPosition = overlayY === 'bottom' && originY === 'top' ? 'above' : 'below';
                }
                if (newPosition !== this._currentPosition) {
                  const overlayRef = this._overlayRef;
                  if (overlayRef) {
                    const classPrefix = `${this._cssClassPrefix}-${PANEL_CLASS}-`;
                    overlayRef.removePanelClass(classPrefix + this._currentPosition);
                    overlayRef.addPanelClass(classPrefix + newPosition);
                  }
                  this._currentPosition = newPosition;
                }
              }
              /** Binds the pointer events to the tooltip trigger. */
              _setupPointerEnterEventsIfNeeded() {
                // Optimization: Defer hooking up events if there's no message or the tooltip is disabled.
                if (this._disabled || !this.message || !this._viewInitialized || this._passiveListeners.length) {
                  return;
                }
                // The mouse events shouldn't be bound on mobile devices, because they can prevent the
                // first tap from firing its click event or can cause the tooltip to open for clicks.
                if (this._platformSupportsMouseEvents()) {
                  this._passiveListeners.push(['mouseenter', event => {
                    this._setupPointerExitEventsIfNeeded();
                    let point = undefined;
                    if (event.x !== undefined && event.y !== undefined) {
                      point = event;
                    }
                    this.show(undefined, point);
                  }]);
                } else if (this.touchGestures !== 'off') {
                  this._disableNativeGesturesIfNecessary();
                  this._passiveListeners.push(['touchstart', event => {
                    var _a;
                    const touch = (_a = event.targetTouches) === null || _a === void 0 ? void 0 : _a[0];
                    const origin = touch ? {
                      x: touch.clientX,
                      y: touch.clientY
                    } : undefined;
                    // Note that it's important that we don't `preventDefault` here,
                    // because it can prevent click events from firing on the element.
                    this._setupPointerExitEventsIfNeeded();
                    clearTimeout(this._touchstartTimeout);
                    this._touchstartTimeout = setTimeout(() => this.show(undefined, origin), LONGPRESS_DELAY);
                  }]);
                }
                this._addListeners(this._passiveListeners);
              }
              _setupPointerExitEventsIfNeeded() {
                if (this._pointerExitEventsInitialized) {
                  return;
                }
                this._pointerExitEventsInitialized = true;
                const exitListeners = [];
                if (this._platformSupportsMouseEvents()) {
                  exitListeners.push(['mouseleave', event => {
                    var _a;
                    const newTarget = event.relatedTarget;
                    if (!newTarget || !((_a = this._overlayRef) === null || _a === void 0 ? void 0 : _a.overlayElement.contains(newTarget))) {
                      this.hide();
                    }
                  }], ['wheel', event => this._wheelListener(event)]);
                } else if (this.touchGestures !== 'off') {
                  this._disableNativeGesturesIfNecessary();
                  const touchendListener = () => {
                    clearTimeout(this._touchstartTimeout);
                    this.hide(this._defaultOptions.touchendHideDelay);
                  };
                  exitListeners.push(['touchend', touchendListener], ['touchcancel', touchendListener]);
                }
                this._addListeners(exitListeners);
                this._passiveListeners.push(...exitListeners);
              }
              _addListeners(listeners) {
                listeners.forEach(([event, listener]) => {
                  this._elementRef.nativeElement.addEventListener(event, listener, passiveListenerOptions);
                });
              }
              _platformSupportsMouseEvents() {
                return !this._platform.IOS && !this._platform.ANDROID;
              }
              /** Listener for the `wheel` event on the element. */
              _wheelListener(event) {
                if (this._isTooltipVisible()) {
                  const elementUnderPointer = this._document.elementFromPoint(event.clientX, event.clientY);
                  const element = this._elementRef.nativeElement;
                  // On non-touch devices we depend on the `mouseleave` event to close the tooltip, but it
                  // won't fire if the user scrolls away using the wheel without moving their cursor. We
                  // work around it by finding the element under the user's cursor and closing the tooltip
                  // if it's not the trigger.
                  if (elementUnderPointer !== element && !element.contains(elementUnderPointer)) {
                    this.hide();
                  }
                }
              }
              /** Disables the native browser gestures, based on how the tooltip has been configured. */
              _disableNativeGesturesIfNecessary() {
                const gestures = this.touchGestures;
                if (gestures !== 'off') {
                  const element = this._elementRef.nativeElement;
                  const style = element.style;
                  // If gestures are set to `auto`, we don't disable text selection on inputs and
                  // textareas, because it prevents the user from typing into them on iOS Safari.
                  if (gestures === 'on' || element.nodeName !== 'INPUT' && element.nodeName !== 'TEXTAREA') {
                    style.userSelect = style.msUserSelect = style.webkitUserSelect = style.MozUserSelect = 'none';
                  }
                  // If we have `auto` gestures and the element uses native HTML dragging,
                  // we don't set `-webkit-user-drag` because it prevents the native behavior.
                  if (gestures === 'on' || !element.draggable) {
                    style.webkitUserDrag = 'none';
                  }
                  style.touchAction = 'none';
                  style.webkitTapHighlightColor = 'transparent';
                }
              }
            } exports('_MatTooltipBase', _MatTooltipBase);
            _MatTooltipBase.ɵfac = function _MatTooltipBase_Factory(t) {
              i0.ɵɵinvalidFactory();
            };
            _MatTooltipBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatTooltipBase,
              inputs: {
                position: ["matTooltipPosition", "position"],
                positionAtOrigin: ["matTooltipPositionAtOrigin", "positionAtOrigin"],
                disabled: ["matTooltipDisabled", "disabled"],
                showDelay: ["matTooltipShowDelay", "showDelay"],
                hideDelay: ["matTooltipHideDelay", "hideDelay"],
                touchGestures: ["matTooltipTouchGestures", "touchGestures"],
                message: ["matTooltip", "message"],
                tooltipClass: ["matTooltipClass", "tooltipClass"]
              }
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatTooltipBase, [{
                type: Directive
              }], function () {
                return [{
                  type: i1.Overlay
                }, {
                  type: i0.ElementRef
                }, {
                  type: i1.ScrollDispatcher
                }, {
                  type: i0.ViewContainerRef
                }, {
                  type: i0.NgZone
                }, {
                  type: i2.Platform
                }, {
                  type: i3.AriaDescriber
                }, {
                  type: i3.FocusMonitor
                }, {
                  type: undefined
                }, {
                  type: i4.Directionality
                }, {
                  type: undefined
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                  }]
                }];
              }, {
                position: [{
                  type: Input,
                  args: ['matTooltipPosition']
                }],
                positionAtOrigin: [{
                  type: Input,
                  args: ['matTooltipPositionAtOrigin']
                }],
                disabled: [{
                  type: Input,
                  args: ['matTooltipDisabled']
                }],
                showDelay: [{
                  type: Input,
                  args: ['matTooltipShowDelay']
                }],
                hideDelay: [{
                  type: Input,
                  args: ['matTooltipHideDelay']
                }],
                touchGestures: [{
                  type: Input,
                  args: ['matTooltipTouchGestures']
                }],
                message: [{
                  type: Input,
                  args: ['matTooltip']
                }],
                tooltipClass: [{
                  type: Input,
                  args: ['matTooltipClass']
                }]
              });
            })();
            /**
             * Directive that attaches a material design tooltip to the host element. Animates the showing and
             * hiding of a tooltip provided position (defaults to below the element).
             *
             * https://material.io/design/components/tooltips.html
             */
            class MatTooltip extends _MatTooltipBase {
              constructor(overlay, elementRef, scrollDispatcher, viewContainerRef, ngZone, platform, ariaDescriber, focusMonitor, scrollStrategy, dir, defaultOptions, _document) {
                super(overlay, elementRef, scrollDispatcher, viewContainerRef, ngZone, platform, ariaDescriber, focusMonitor, scrollStrategy, dir, defaultOptions, _document);
                this._tooltipComponent = TooltipComponent;
                this._cssClassPrefix = 'mat-mdc';
                this._viewportMargin = MIN_VIEWPORT_TOOLTIP_THRESHOLD;
              }
              _addOffset(position) {
                const offset = UNBOUNDED_ANCHOR_GAP;
                const isLtr = !this._dir || this._dir.value == 'ltr';
                if (position.originY === 'top') {
                  position.offsetY = -offset;
                } else if (position.originY === 'bottom') {
                  position.offsetY = offset;
                } else if (position.originX === 'start') {
                  position.offsetX = isLtr ? -offset : offset;
                } else if (position.originX === 'end') {
                  position.offsetX = isLtr ? offset : -offset;
                }
                return position;
              }
            } exports('MatTooltip', MatTooltip);
            MatTooltip.ɵfac = function MatTooltip_Factory(t) {
              return new (t || MatTooltip)(i0.ɵɵdirectiveInject(i1.Overlay), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.ScrollDispatcher), i0.ɵɵdirectiveInject(i0.ViewContainerRef), i0.ɵɵdirectiveInject(i0.NgZone), i0.ɵɵdirectiveInject(i2.Platform), i0.ɵɵdirectiveInject(i3.AriaDescriber), i0.ɵɵdirectiveInject(i3.FocusMonitor), i0.ɵɵdirectiveInject(MAT_TOOLTIP_SCROLL_STRATEGY), i0.ɵɵdirectiveInject(i4.Directionality, 8), i0.ɵɵdirectiveInject(MAT_TOOLTIP_DEFAULT_OPTIONS, 8), i0.ɵɵdirectiveInject(DOCUMENT));
            };
            MatTooltip.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatTooltip,
              selectors: [["", "matTooltip", ""]],
              hostAttrs: [1, "mat-mdc-tooltip-trigger"],
              exportAs: ["matTooltip"],
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTooltip, [{
                type: Directive,
                args: [{
                  selector: '[matTooltip]',
                  exportAs: 'matTooltip',
                  host: {
                    'class': 'mat-mdc-tooltip-trigger'
                  }
                }]
              }], function () {
                return [{
                  type: i1.Overlay
                }, {
                  type: i0.ElementRef
                }, {
                  type: i1.ScrollDispatcher
                }, {
                  type: i0.ViewContainerRef
                }, {
                  type: i0.NgZone
                }, {
                  type: i2.Platform
                }, {
                  type: i3.AriaDescriber
                }, {
                  type: i3.FocusMonitor
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [MAT_TOOLTIP_SCROLL_STRATEGY]
                  }]
                }, {
                  type: i4.Directionality,
                  decorators: [{
                    type: Optional
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_TOOLTIP_DEFAULT_OPTIONS]
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                  }]
                }];
              }, null);
            })();
            class _TooltipComponentBase {
              constructor(_changeDetectorRef, animationMode) {
                this._changeDetectorRef = _changeDetectorRef;
                /** Whether interactions on the page should close the tooltip */
                this._closeOnInteraction = false;
                /** Whether the tooltip is currently visible. */
                this._isVisible = false;
                /** Subject for notifying that the tooltip has been hidden from the view */
                this._onHide = new Subject();
                this._animationsDisabled = animationMode === 'NoopAnimations';
              }
              /**
               * Shows the tooltip with an animation originating from the provided origin
               * @param delay Amount of milliseconds to the delay showing the tooltip.
               */
              show(delay) {
                // Cancel the delayed hide if it is scheduled
                clearTimeout(this._hideTimeoutId);
                this._showTimeoutId = setTimeout(() => {
                  this._toggleVisibility(true);
                  this._showTimeoutId = undefined;
                }, delay);
              }
              /**
               * Begins the animation to hide the tooltip after the provided delay in ms.
               * @param delay Amount of milliseconds to delay showing the tooltip.
               */
              hide(delay) {
                // Cancel the delayed show if it is scheduled
                clearTimeout(this._showTimeoutId);
                this._hideTimeoutId = setTimeout(() => {
                  this._toggleVisibility(false);
                  this._hideTimeoutId = undefined;
                }, delay);
              }
              /** Returns an observable that notifies when the tooltip has been hidden from view. */
              afterHidden() {
                return this._onHide;
              }
              /** Whether the tooltip is being displayed. */
              isVisible() {
                return this._isVisible;
              }
              ngOnDestroy() {
                this._cancelPendingAnimations();
                this._onHide.complete();
                this._triggerElement = null;
              }
              /**
               * Interactions on the HTML body should close the tooltip immediately as defined in the
               * material design spec.
               * https://material.io/design/components/tooltips.html#behavior
               */
              _handleBodyInteraction() {
                if (this._closeOnInteraction) {
                  this.hide(0);
                }
              }
              /**
               * Marks that the tooltip needs to be checked in the next change detection run.
               * Mainly used for rendering the initial text before positioning a tooltip, which
               * can be problematic in components with OnPush change detection.
               */
              _markForCheck() {
                this._changeDetectorRef.markForCheck();
              }
              _handleMouseLeave({
                relatedTarget
              }) {
                if (!relatedTarget || !this._triggerElement.contains(relatedTarget)) {
                  if (this.isVisible()) {
                    this.hide(this._mouseLeaveHideDelay);
                  } else {
                    this._finalizeAnimation(false);
                  }
                }
              }
              /**
               * Callback for when the timeout in this.show() gets completed.
               * This method is only needed by the mdc-tooltip, and so it is only implemented
               * in the mdc-tooltip, not here.
               */
              _onShow() {}
              /** Event listener dispatched when an animation on the tooltip finishes. */
              _handleAnimationEnd({
                animationName
              }) {
                if (animationName === this._showAnimation || animationName === this._hideAnimation) {
                  this._finalizeAnimation(animationName === this._showAnimation);
                }
              }
              /** Cancels any pending animation sequences. */
              _cancelPendingAnimations() {
                clearTimeout(this._showTimeoutId);
                clearTimeout(this._hideTimeoutId);
                this._showTimeoutId = this._hideTimeoutId = undefined;
              }
              /** Handles the cleanup after an animation has finished. */
              _finalizeAnimation(toVisible) {
                if (toVisible) {
                  this._closeOnInteraction = true;
                } else if (!this.isVisible()) {
                  this._onHide.next();
                }
              }
              /** Toggles the visibility of the tooltip element. */
              _toggleVisibility(isVisible) {
                // We set the classes directly here ourselves so that toggling the tooltip state
                // isn't bound by change detection. This allows us to hide it even if the
                // view ref has been detached from the CD tree.
                const tooltip = this._tooltip.nativeElement;
                const showClass = this._showAnimation;
                const hideClass = this._hideAnimation;
                tooltip.classList.remove(isVisible ? hideClass : showClass);
                tooltip.classList.add(isVisible ? showClass : hideClass);
                this._isVisible = isVisible;
                // It's common for internal apps to disable animations using `* { animation: none !important }`
                // which can break the opening sequence. Try to detect such cases and work around them.
                if (isVisible && !this._animationsDisabled && typeof getComputedStyle === 'function') {
                  const styles = getComputedStyle(tooltip);
                  // Use `getPropertyValue` to avoid issues with property renaming.
                  if (styles.getPropertyValue('animation-duration') === '0s' || styles.getPropertyValue('animation-name') === 'none') {
                    this._animationsDisabled = true;
                  }
                }
                if (isVisible) {
                  this._onShow();
                }
                if (this._animationsDisabled) {
                  tooltip.classList.add('_mat-animation-noopable');
                  this._finalizeAnimation(isVisible);
                }
              }
            } exports('_TooltipComponentBase', _TooltipComponentBase);
            _TooltipComponentBase.ɵfac = function _TooltipComponentBase_Factory(t) {
              return new (t || _TooltipComponentBase)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(ANIMATION_MODULE_TYPE, 8));
            };
            _TooltipComponentBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _TooltipComponentBase
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_TooltipComponentBase, [{
                type: Directive
              }], function () {
                return [{
                  type: i0.ChangeDetectorRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }];
              }, null);
            })();
            /**
             * Internal component that wraps the tooltip's content.
             * @docs-private
             */
            class TooltipComponent extends _TooltipComponentBase {
              constructor(changeDetectorRef, _elementRef, animationMode) {
                super(changeDetectorRef, animationMode);
                this._elementRef = _elementRef;
                /* Whether the tooltip text overflows to multiple lines */
                this._isMultiline = false;
                this._showAnimation = 'mat-mdc-tooltip-show';
                this._hideAnimation = 'mat-mdc-tooltip-hide';
              }
              _onShow() {
                this._isMultiline = this._isTooltipMultiline();
                this._markForCheck();
              }
              /** Whether the tooltip text has overflown to the next line */
              _isTooltipMultiline() {
                const rect = this._elementRef.nativeElement.getBoundingClientRect();
                return rect.height > MIN_HEIGHT && rect.width >= MAX_WIDTH;
              }
            } exports('TooltipComponent', TooltipComponent);
            TooltipComponent.ɵfac = function TooltipComponent_Factory(t) {
              return new (t || TooltipComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(ANIMATION_MODULE_TYPE, 8));
            };
            TooltipComponent.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: TooltipComponent,
              selectors: [["mat-tooltip-component"]],
              viewQuery: function TooltipComponent_Query(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵviewQuery(_c0, 7);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._tooltip = _t.first);
                }
              },
              hostAttrs: ["aria-hidden", "true"],
              hostVars: 2,
              hostBindings: function TooltipComponent_HostBindings(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵlistener("mouseleave", function TooltipComponent_mouseleave_HostBindingHandler($event) {
                    return ctx._handleMouseLeave($event);
                  });
                }
                if (rf & 2) {
                  i0.ɵɵstyleProp("zoom", ctx.isVisible() ? 1 : null);
                }
              },
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 4,
              vars: 4,
              consts: [[1, "mdc-tooltip", "mdc-tooltip--shown", "mat-mdc-tooltip", 3, "ngClass", "animationend"], ["tooltip", ""], [1, "mdc-tooltip__surface", "mdc-tooltip__surface-animation"]],
              template: function TooltipComponent_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵelementStart(0, "div", 0, 1);
                  i0.ɵɵlistener("animationend", function TooltipComponent_Template_div_animationend_0_listener($event) {
                    return ctx._handleAnimationEnd($event);
                  });
                  i0.ɵɵelementStart(2, "div", 2);
                  i0.ɵɵtext(3);
                  i0.ɵɵelementEnd()();
                }
                if (rf & 2) {
                  i0.ɵɵclassProp("mdc-tooltip--multiline", ctx._isMultiline);
                  i0.ɵɵproperty("ngClass", ctx.tooltipClass);
                  i0.ɵɵadvance(3);
                  i0.ɵɵtextInterpolate(ctx.message);
                }
              },
              dependencies: [i5.NgClass],
              styles: [".mdc-tooltip__surface{word-break:var(--mdc-tooltip-word-break, normal);overflow-wrap:anywhere}.mdc-tooltip{position:fixed;display:none;z-index:9}.mdc-tooltip-wrapper--rich{position:relative}.mdc-tooltip--shown,.mdc-tooltip--showing,.mdc-tooltip--hide{display:inline-flex}.mdc-tooltip--shown.mdc-tooltip--rich,.mdc-tooltip--showing.mdc-tooltip--rich,.mdc-tooltip--hide.mdc-tooltip--rich{display:inline-block;left:-320px;position:absolute}.mdc-tooltip__surface{line-height:16px;padding:4px 8px;min-width:40px;max-width:200px;min-height:24px;max-height:40vh;box-sizing:border-box;overflow:hidden;text-align:center}.mdc-tooltip__surface::before{position:absolute;box-sizing:border-box;width:100%;height:100%;top:0;left:0;border:1px solid rgba(0,0,0,0);border-radius:inherit;content:\"\";pointer-events:none}@media screen and (forced-colors: active){.mdc-tooltip__surface::before{border-color:CanvasText}}.mdc-tooltip--rich .mdc-tooltip__surface{align-items:flex-start;display:flex;flex-direction:column;min-height:24px;min-width:40px;max-width:320px;position:relative}.mdc-tooltip--multiline .mdc-tooltip__surface{text-align:left}[dir=rtl] .mdc-tooltip--multiline .mdc-tooltip__surface,.mdc-tooltip--multiline .mdc-tooltip__surface[dir=rtl]{text-align:right}.mdc-tooltip__surface .mdc-tooltip__title{margin:0 8px}.mdc-tooltip__surface .mdc-tooltip__content{max-width:calc(200px - (2 * 8px));margin:8px;text-align:left}[dir=rtl] .mdc-tooltip__surface .mdc-tooltip__content,.mdc-tooltip__surface .mdc-tooltip__content[dir=rtl]{text-align:right}.mdc-tooltip--rich .mdc-tooltip__surface .mdc-tooltip__content{max-width:calc(320px - (2 * 8px));align-self:stretch}.mdc-tooltip__surface .mdc-tooltip__content-link{text-decoration:none}.mdc-tooltip--rich-actions,.mdc-tooltip__content,.mdc-tooltip__title{z-index:1}.mdc-tooltip__surface-animation{opacity:0;transform:scale(0.8);will-change:transform,opacity}.mdc-tooltip--shown .mdc-tooltip__surface-animation{transform:scale(1);opacity:1}.mdc-tooltip--hide .mdc-tooltip__surface-animation{transform:scale(1)}.mdc-tooltip__caret-surface-top,.mdc-tooltip__caret-surface-bottom{position:absolute;height:24px;width:24px;transform:rotate(35deg) skewY(20deg) scaleX(0.9396926208)}.mdc-tooltip__caret-surface-top .mdc-elevation-overlay,.mdc-tooltip__caret-surface-bottom .mdc-elevation-overlay{width:100%;height:100%;top:0;left:0}.mdc-tooltip__caret-surface-bottom{outline:1px solid rgba(0,0,0,0);z-index:-1}@media screen and (forced-colors: active){.mdc-tooltip__caret-surface-bottom{outline-color:CanvasText}}.mdc-tooltip__surface{background-color:var(--mdc-plain-tooltip-container-color, #fff)}.mdc-tooltip__surface{border-radius:var(--mdc-plain-tooltip-container-shape, var(--mdc-shape-small, 4px))}.mdc-tooltip__caret-surface-top,.mdc-tooltip__caret-surface-bottom{border-radius:var(--mdc-plain-tooltip-container-shape, var(--mdc-shape-small, 4px))}.mdc-tooltip__surface{color:var(--mdc-plain-tooltip-supporting-text-color, #000)}.mdc-tooltip__surface{font-family:var(--mdc-plain-tooltip-supporting-text-font, inherit);font-size:var(--mdc-plain-tooltip-supporting-text-size, inherit);font-weight:var(--mdc-plain-tooltip-supporting-text-weight, inherit);letter-spacing:var(--mdc-plain-tooltip-supporting-text-tracking, inherit)}.mat-mdc-tooltip{position:relative;transform:scale(0)}.mat-mdc-tooltip::before{content:\"\";top:0;right:0;bottom:0;left:0;z-index:-1;position:absolute}.mat-mdc-tooltip-panel-below .mat-mdc-tooltip::before{top:-8px}.mat-mdc-tooltip-panel-above .mat-mdc-tooltip::before{bottom:-8px}.mat-mdc-tooltip-panel-right .mat-mdc-tooltip::before{left:-8px}.mat-mdc-tooltip-panel-left .mat-mdc-tooltip::before{right:-8px}.mat-mdc-tooltip._mat-animation-noopable{animation:none;transform:scale(1)}.mat-mdc-tooltip-panel-non-interactive{pointer-events:none}@keyframes mat-mdc-tooltip-show{0%{opacity:0;transform:scale(0.8)}100%{opacity:1;transform:scale(1)}}@keyframes mat-mdc-tooltip-hide{0%{opacity:1;transform:scale(1)}100%{opacity:0;transform:scale(0.8)}}.mat-mdc-tooltip-show{animation:mat-mdc-tooltip-show 150ms cubic-bezier(0, 0, 0.2, 1) forwards}.mat-mdc-tooltip-hide{animation:mat-mdc-tooltip-hide 75ms cubic-bezier(0.4, 0, 1, 1) forwards}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TooltipComponent, [{
                type: Component,
                args: [{
                  selector: 'mat-tooltip-component',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  host: {
                    // Forces the element to have a layout in IE and Edge. This fixes issues where the element
                    // won't be rendered if the animations are disabled or there is no web animations polyfill.
                    '[style.zoom]': 'isVisible() ? 1 : null',
                    '(mouseleave)': '_handleMouseLeave($event)',
                    'aria-hidden': 'true'
                  },
                  template: "<div\n  #tooltip\n  class=\"mdc-tooltip mdc-tooltip--shown mat-mdc-tooltip\"\n  [ngClass]=\"tooltipClass\"\n  (animationend)=\"_handleAnimationEnd($event)\"\n  [class.mdc-tooltip--multiline]=\"_isMultiline\">\n  <div class=\"mdc-tooltip__surface mdc-tooltip__surface-animation\">{{message}}</div>\n</div>\n",
                  styles: [".mdc-tooltip__surface{word-break:var(--mdc-tooltip-word-break, normal);overflow-wrap:anywhere}.mdc-tooltip{position:fixed;display:none;z-index:9}.mdc-tooltip-wrapper--rich{position:relative}.mdc-tooltip--shown,.mdc-tooltip--showing,.mdc-tooltip--hide{display:inline-flex}.mdc-tooltip--shown.mdc-tooltip--rich,.mdc-tooltip--showing.mdc-tooltip--rich,.mdc-tooltip--hide.mdc-tooltip--rich{display:inline-block;left:-320px;position:absolute}.mdc-tooltip__surface{line-height:16px;padding:4px 8px;min-width:40px;max-width:200px;min-height:24px;max-height:40vh;box-sizing:border-box;overflow:hidden;text-align:center}.mdc-tooltip__surface::before{position:absolute;box-sizing:border-box;width:100%;height:100%;top:0;left:0;border:1px solid rgba(0,0,0,0);border-radius:inherit;content:\"\";pointer-events:none}@media screen and (forced-colors: active){.mdc-tooltip__surface::before{border-color:CanvasText}}.mdc-tooltip--rich .mdc-tooltip__surface{align-items:flex-start;display:flex;flex-direction:column;min-height:24px;min-width:40px;max-width:320px;position:relative}.mdc-tooltip--multiline .mdc-tooltip__surface{text-align:left}[dir=rtl] .mdc-tooltip--multiline .mdc-tooltip__surface,.mdc-tooltip--multiline .mdc-tooltip__surface[dir=rtl]{text-align:right}.mdc-tooltip__surface .mdc-tooltip__title{margin:0 8px}.mdc-tooltip__surface .mdc-tooltip__content{max-width:calc(200px - (2 * 8px));margin:8px;text-align:left}[dir=rtl] .mdc-tooltip__surface .mdc-tooltip__content,.mdc-tooltip__surface .mdc-tooltip__content[dir=rtl]{text-align:right}.mdc-tooltip--rich .mdc-tooltip__surface .mdc-tooltip__content{max-width:calc(320px - (2 * 8px));align-self:stretch}.mdc-tooltip__surface .mdc-tooltip__content-link{text-decoration:none}.mdc-tooltip--rich-actions,.mdc-tooltip__content,.mdc-tooltip__title{z-index:1}.mdc-tooltip__surface-animation{opacity:0;transform:scale(0.8);will-change:transform,opacity}.mdc-tooltip--shown .mdc-tooltip__surface-animation{transform:scale(1);opacity:1}.mdc-tooltip--hide .mdc-tooltip__surface-animation{transform:scale(1)}.mdc-tooltip__caret-surface-top,.mdc-tooltip__caret-surface-bottom{position:absolute;height:24px;width:24px;transform:rotate(35deg) skewY(20deg) scaleX(0.9396926208)}.mdc-tooltip__caret-surface-top .mdc-elevation-overlay,.mdc-tooltip__caret-surface-bottom .mdc-elevation-overlay{width:100%;height:100%;top:0;left:0}.mdc-tooltip__caret-surface-bottom{outline:1px solid rgba(0,0,0,0);z-index:-1}@media screen and (forced-colors: active){.mdc-tooltip__caret-surface-bottom{outline-color:CanvasText}}.mdc-tooltip__surface{background-color:var(--mdc-plain-tooltip-container-color, #fff)}.mdc-tooltip__surface{border-radius:var(--mdc-plain-tooltip-container-shape, var(--mdc-shape-small, 4px))}.mdc-tooltip__caret-surface-top,.mdc-tooltip__caret-surface-bottom{border-radius:var(--mdc-plain-tooltip-container-shape, var(--mdc-shape-small, 4px))}.mdc-tooltip__surface{color:var(--mdc-plain-tooltip-supporting-text-color, #000)}.mdc-tooltip__surface{font-family:var(--mdc-plain-tooltip-supporting-text-font, inherit);font-size:var(--mdc-plain-tooltip-supporting-text-size, inherit);font-weight:var(--mdc-plain-tooltip-supporting-text-weight, inherit);letter-spacing:var(--mdc-plain-tooltip-supporting-text-tracking, inherit)}.mat-mdc-tooltip{position:relative;transform:scale(0)}.mat-mdc-tooltip::before{content:\"\";top:0;right:0;bottom:0;left:0;z-index:-1;position:absolute}.mat-mdc-tooltip-panel-below .mat-mdc-tooltip::before{top:-8px}.mat-mdc-tooltip-panel-above .mat-mdc-tooltip::before{bottom:-8px}.mat-mdc-tooltip-panel-right .mat-mdc-tooltip::before{left:-8px}.mat-mdc-tooltip-panel-left .mat-mdc-tooltip::before{right:-8px}.mat-mdc-tooltip._mat-animation-noopable{animation:none;transform:scale(1)}.mat-mdc-tooltip-panel-non-interactive{pointer-events:none}@keyframes mat-mdc-tooltip-show{0%{opacity:0;transform:scale(0.8)}100%{opacity:1;transform:scale(1)}}@keyframes mat-mdc-tooltip-hide{0%{opacity:1;transform:scale(1)}100%{opacity:0;transform:scale(0.8)}}.mat-mdc-tooltip-show{animation:mat-mdc-tooltip-show 150ms cubic-bezier(0, 0, 0.2, 1) forwards}.mat-mdc-tooltip-hide{animation:mat-mdc-tooltip-hide 75ms cubic-bezier(0.4, 0, 1, 1) forwards}"]
                }]
              }], function () {
                return [{
                  type: i0.ChangeDetectorRef
                }, {
                  type: i0.ElementRef
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }];
              }, {
                _tooltip: [{
                  type: ViewChild,
                  args: ['tooltip', {
                    // Use a static query here since we interact directly with
                    // the DOM which can happen before `ngAfterViewInit`.
                    static: true
                  }]
                }]
              });
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * Animations used by MatTooltip.
             * @docs-private
             */
            const matTooltipAnimations = exports('matTooltipAnimations', {
              /** Animation that transitions a tooltip in and out. */
              tooltipState: trigger('state', [
              // TODO(crisbeto): these values are based on MDC's CSS.
              // We should be able to use their styles directly once we land #19432.
              state('initial, void, hidden', style({
                opacity: 0,
                transform: 'scale(0.8)'
              })), state('visible', style({
                transform: 'scale(1)'
              })), transition('* => visible', animate('150ms cubic-bezier(0, 0, 0.2, 1)')), transition('* => hidden', animate('75ms cubic-bezier(0.4, 0, 1, 1)'))])
            });

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatTooltipModule {} exports('MatTooltipModule', MatTooltipModule);
            MatTooltipModule.ɵfac = function MatTooltipModule_Factory(t) {
              return new (t || MatTooltipModule)();
            };
            MatTooltipModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatTooltipModule
            });
            MatTooltipModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              providers: [MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER],
              imports: [A11yModule, CommonModule, OverlayModule, MatCommonModule, MatCommonModule, CdkScrollableModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatTooltipModule, [{
                type: NgModule,
                args: [{
                  imports: [A11yModule, CommonModule, OverlayModule, MatCommonModule],
                  exports: [MatTooltip, TooltipComponent, MatCommonModule, CdkScrollableModule],
                  declarations: [MatTooltip, TooltipComponent],
                  providers: [MAT_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-tooltip.js.map
