/* esm-bundle - @angular/material/legacy-progress-bar@15.2.9 - Ivy - system format - es2020 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/common', '@angular/material/core', '@angular/cdk/coercion', '@angular/material/progress-bar', '@angular/platform-browser/animations', 'rxjs', 'rxjs/operators'], (function (exports) {
    'use strict';
    var i0, Component, ChangeDetectionStrategy, ViewEncapsulation, Optional, Inject, Input, ViewChild, Output, NgModule, EventEmitter, i1, CommonModule, mixinColor, MatCommonModule, coerceNumberProperty, MAT_PROGRESS_BAR_LOCATION, MAT_PROGRESS_BAR_DEFAULT_OPTIONS, ANIMATION_MODULE_TYPE, Subscription, fromEvent, filter;
    return {
        setters: [function (module) {
            i0 = module;
            Component = module.Component;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ViewEncapsulation = module.ViewEncapsulation;
            Optional = module.Optional;
            Inject = module.Inject;
            Input = module.Input;
            ViewChild = module.ViewChild;
            Output = module.Output;
            NgModule = module.NgModule;
            EventEmitter = module.EventEmitter;
        }, function (module) {
            i1 = module;
            CommonModule = module.CommonModule;
        }, function (module) {
            mixinColor = module.mixinColor;
            MatCommonModule = module.MatCommonModule;
        }, function (module) {
            coerceNumberProperty = module.coerceNumberProperty;
        }, function (module) {
            MAT_PROGRESS_BAR_LOCATION = module.MAT_PROGRESS_BAR_LOCATION;
            MAT_PROGRESS_BAR_DEFAULT_OPTIONS = module.MAT_PROGRESS_BAR_DEFAULT_OPTIONS;
            exports({ MAT_LEGACY_PROGRESS_BAR_DEFAULT_OPTIONS: module.MAT_PROGRESS_BAR_DEFAULT_OPTIONS, MAT_LEGACY_PROGRESS_BAR_LOCATION: module.MAT_PROGRESS_BAR_LOCATION, MAT_LEGACY_PROGRESS_BAR_LOCATION_FACTORY: module.MAT_PROGRESS_BAR_LOCATION_FACTORY });
        }, function (module) {
            ANIMATION_MODULE_TYPE = module.ANIMATION_MODULE_TYPE;
        }, function (module) {
            Subscription = module.Subscription;
            fromEvent = module.fromEvent;
        }, function (module) {
            filter = module.filter;
        }],
        execute: (function () {

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            // TODO(josephperrott): Add ARIA attributes for progress bar "for".
            // Boilerplate for applying mixins to MatProgressBar.
            /** @docs-private */
            const _c0 = ["primaryValueBar"];
            const _MatProgressBarBase = mixinColor(class {
              constructor(_elementRef) {
                this._elementRef = _elementRef;
              }
            }, 'primary');
            /** Counter used to generate unique IDs for progress bars. */
            let progressbarId = 0;
            /**
             * `<mat-progress-bar>` component.
             * @deprecated Use `MatProgressBar` from `@angular/material/progress-bar` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyProgressBar extends _MatProgressBarBase {
              constructor(elementRef, _ngZone, _animationMode,
              /**
               * @deprecated `location` parameter to be made required.
               * @breaking-change 8.0.0
               */
              location, defaults,
              /**
               * @deprecated `_changeDetectorRef` parameter to be made required.
               * @breaking-change 11.0.0
               */
              _changeDetectorRef) {
                super(elementRef);
                this._ngZone = _ngZone;
                this._animationMode = _animationMode;
                this._changeDetectorRef = _changeDetectorRef;
                /** Flag that indicates whether NoopAnimations mode is set to true. */
                this._isNoopAnimation = false;
                this._value = 0;
                this._bufferValue = 0;
                /**
                 * Event emitted when animation of the primary progress bar completes. This event will not
                 * be emitted when animations are disabled, nor will it be emitted for modes with continuous
                 * animations (indeterminate and query).
                 */
                this.animationEnd = new EventEmitter();
                /** Reference to animation end subscription to be unsubscribed on destroy. */
                this._animationEndSubscription = Subscription.EMPTY;
                /**
                 * Mode of the progress bar.
                 *
                 * Input must be one of these values: determinate, indeterminate, buffer, query, defaults to
                 * 'determinate'.
                 * Mirrored to mode attribute.
                 */
                this.mode = 'determinate';
                /** ID of the progress bar. */
                this.progressbarId = `mat-progress-bar-${progressbarId++}`;
                // We need to prefix the SVG reference with the current path, otherwise they won't work
                // in Safari if the page has a `<base>` tag. Note that we need quotes inside the `url()`,
                // because named route URLs can contain parentheses (see #12338). Also we don't use `Location`
                // since we can't tell the difference between whether the consumer is using the hash location
                // strategy or not, because `Location` normalizes both `/#/foo/bar` and `/foo/bar` to
                // the same thing.
                const path = location ? location.getPathname().split('#')[0] : '';
                this._rectangleFillValue = `url('${path}#${this.progressbarId}')`;
                this._isNoopAnimation = _animationMode === 'NoopAnimations';
                if (defaults) {
                  if (defaults.color) {
                    this.color = this.defaultColor = defaults.color;
                  }
                  this.mode = defaults.mode || this.mode;
                }
              }
              /** Value of the progress bar. Defaults to zero. Mirrored to aria-valuenow. */
              get value() {
                return this._value;
              }
              set value(v) {
                this._value = clamp(coerceNumberProperty(v) || 0);
                // @breaking-change 11.0.0 Remove null check for _changeDetectorRef.
                this._changeDetectorRef?.markForCheck();
              }
              /** Buffer value of the progress bar. Defaults to zero. */
              get bufferValue() {
                return this._bufferValue;
              }
              set bufferValue(v) {
                this._bufferValue = clamp(v || 0);
                // @breaking-change 11.0.0 Remove null check for _changeDetectorRef.
                this._changeDetectorRef?.markForCheck();
              }
              /** Gets the current transform value for the progress bar's primary indicator. */
              _primaryTransform() {
                // We use a 3d transform to work around some rendering issues in iOS Safari. See #19328.
                const scale = this.value / 100;
                return {
                  transform: `scale3d(${scale}, 1, 1)`
                };
              }
              /**
               * Gets the current transform value for the progress bar's buffer indicator. Only used if the
               * progress mode is set to buffer, otherwise returns an undefined, causing no transformation.
               */
              _bufferTransform() {
                if (this.mode === 'buffer') {
                  // We use a 3d transform to work around some rendering issues in iOS Safari. See #19328.
                  const scale = this.bufferValue / 100;
                  return {
                    transform: `scale3d(${scale}, 1, 1)`
                  };
                }
                return null;
              }
              ngAfterViewInit() {
                // Run outside angular so change detection didn't get triggered on every transition end
                // instead only on the animation that we care about (primary value bar's transitionend)
                this._ngZone.runOutsideAngular(() => {
                  const element = this._primaryValueBar.nativeElement;
                  this._animationEndSubscription = fromEvent(element, 'transitionend').pipe(filter(e => e.target === element)).subscribe(() => {
                    if (this.animationEnd.observers.length === 0) {
                      return;
                    }
                    if (this.mode === 'determinate' || this.mode === 'buffer') {
                      this._ngZone.run(() => this.animationEnd.next({
                        value: this.value
                      }));
                    }
                  });
                });
              }
              ngOnDestroy() {
                this._animationEndSubscription.unsubscribe();
              }
            } exports('MatLegacyProgressBar', MatLegacyProgressBar);
            MatLegacyProgressBar.ɵfac = function MatLegacyProgressBar_Factory(t) {
              return new (t || MatLegacyProgressBar)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.NgZone), i0.ɵɵdirectiveInject(ANIMATION_MODULE_TYPE, 8), i0.ɵɵdirectiveInject(MAT_PROGRESS_BAR_LOCATION, 8), i0.ɵɵdirectiveInject(MAT_PROGRESS_BAR_DEFAULT_OPTIONS, 8), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef));
            };
            MatLegacyProgressBar.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatLegacyProgressBar,
              selectors: [["mat-progress-bar"]],
              viewQuery: function MatLegacyProgressBar_Query(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵviewQuery(_c0, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._primaryValueBar = _t.first);
                }
              },
              hostAttrs: ["role", "progressbar", "aria-valuemin", "0", "aria-valuemax", "100", "tabindex", "-1", 1, "mat-progress-bar"],
              hostVars: 4,
              hostBindings: function MatLegacyProgressBar_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵattribute("aria-valuenow", ctx.mode === "indeterminate" || ctx.mode === "query" ? null : ctx.value)("mode", ctx.mode);
                  i0.ɵɵclassProp("_mat-animation-noopable", ctx._isNoopAnimation);
                }
              },
              inputs: {
                color: "color",
                value: "value",
                bufferValue: "bufferValue",
                mode: "mode"
              },
              outputs: {
                animationEnd: "animationEnd"
              },
              exportAs: ["matProgressBar"],
              features: [i0.ɵɵInheritDefinitionFeature],
              decls: 10,
              vars: 4,
              consts: [["aria-hidden", "true"], ["width", "100%", "height", "4", "focusable", "false", 1, "mat-progress-bar-background", "mat-progress-bar-element"], ["x", "4", "y", "0", "width", "8", "height", "4", "patternUnits", "userSpaceOnUse", 3, "id"], ["cx", "2", "cy", "2", "r", "2"], ["width", "100%", "height", "100%"], [1, "mat-progress-bar-buffer", "mat-progress-bar-element", 3, "ngStyle"], [1, "mat-progress-bar-primary", "mat-progress-bar-fill", "mat-progress-bar-element", 3, "ngStyle"], ["primaryValueBar", ""], [1, "mat-progress-bar-secondary", "mat-progress-bar-fill", "mat-progress-bar-element"]],
              template: function MatLegacyProgressBar_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵelementStart(0, "div", 0);
                  i0.ɵɵnamespaceSVG();
                  i0.ɵɵelementStart(1, "svg", 1)(2, "defs")(3, "pattern", 2);
                  i0.ɵɵelement(4, "circle", 3);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵelement(5, "rect", 4);
                  i0.ɵɵelementEnd();
                  i0.ɵɵnamespaceHTML();
                  i0.ɵɵelement(6, "div", 5)(7, "div", 6, 7)(9, "div", 8);
                  i0.ɵɵelementEnd();
                }
                if (rf & 2) {
                  i0.ɵɵadvance(3);
                  i0.ɵɵproperty("id", ctx.progressbarId);
                  i0.ɵɵadvance(2);
                  i0.ɵɵattribute("fill", ctx._rectangleFillValue);
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngStyle", ctx._bufferTransform());
                  i0.ɵɵadvance(1);
                  i0.ɵɵproperty("ngStyle", ctx._primaryTransform());
                }
              },
              dependencies: [i1.NgStyle],
              styles: [".mat-progress-bar{display:block;height:4px;overflow:hidden;position:relative;transition:opacity 250ms linear;width:100%}.mat-progress-bar._mat-animation-noopable{transition:none !important;animation:none !important}.mat-progress-bar .mat-progress-bar-element,.mat-progress-bar .mat-progress-bar-fill::after{height:100%;position:absolute;width:100%}.mat-progress-bar .mat-progress-bar-background{width:calc(100% + 10px)}.cdk-high-contrast-active .mat-progress-bar .mat-progress-bar-background{display:none}.mat-progress-bar .mat-progress-bar-buffer{transform-origin:top left;transition:transform 250ms ease}.cdk-high-contrast-active .mat-progress-bar .mat-progress-bar-buffer{border-top:solid 5px;opacity:.5}.mat-progress-bar .mat-progress-bar-secondary{display:none}.mat-progress-bar .mat-progress-bar-fill{animation:none;transform-origin:top left;transition:transform 250ms ease}.cdk-high-contrast-active .mat-progress-bar .mat-progress-bar-fill{border-top:solid 4px}.mat-progress-bar .mat-progress-bar-fill::after{animation:none;content:\"\";display:inline-block;left:0}.mat-progress-bar[dir=rtl],[dir=rtl] .mat-progress-bar{transform:rotateY(180deg)}.mat-progress-bar[mode=query]{transform:rotateZ(180deg)}.mat-progress-bar[mode=query][dir=rtl],[dir=rtl] .mat-progress-bar[mode=query]{transform:rotateZ(180deg) rotateY(180deg)}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-fill,.mat-progress-bar[mode=query] .mat-progress-bar-fill{transition:none}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary,.mat-progress-bar[mode=query] .mat-progress-bar-primary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-translate 2000ms infinite linear;left:-145.166611%}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-primary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-scale 2000ms infinite linear}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary,.mat-progress-bar[mode=query] .mat-progress-bar-secondary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-translate 2000ms infinite linear;left:-54.888891%;display:block}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-secondary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-scale 2000ms infinite linear}.mat-progress-bar[mode=buffer] .mat-progress-bar-background{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-background-scroll 250ms infinite linear;display:block}.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-buffer,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-background{animation:none;transition-duration:1ms}@keyframes mat-progress-bar-primary-indeterminate-translate{0%{transform:translateX(0)}20%{animation-timing-function:cubic-bezier(0.5, 0, 0.701732, 0.495819);transform:translateX(0)}59.15%{animation-timing-function:cubic-bezier(0.302435, 0.381352, 0.55, 0.956352);transform:translateX(83.67142%)}100%{transform:translateX(200.611057%)}}@keyframes mat-progress-bar-primary-indeterminate-scale{0%{transform:scaleX(0.08)}36.65%{animation-timing-function:cubic-bezier(0.334731, 0.12482, 0.785844, 1);transform:scaleX(0.08)}69.15%{animation-timing-function:cubic-bezier(0.06, 0.11, 0.6, 1);transform:scaleX(0.661479)}100%{transform:scaleX(0.08)}}@keyframes mat-progress-bar-secondary-indeterminate-translate{0%{animation-timing-function:cubic-bezier(0.15, 0, 0.515058, 0.409685);transform:translateX(0)}25%{animation-timing-function:cubic-bezier(0.31033, 0.284058, 0.8, 0.733712);transform:translateX(37.651913%)}48.35%{animation-timing-function:cubic-bezier(0.4, 0.627035, 0.6, 0.902026);transform:translateX(84.386165%)}100%{transform:translateX(160.277782%)}}@keyframes mat-progress-bar-secondary-indeterminate-scale{0%{animation-timing-function:cubic-bezier(0.15, 0, 0.515058, 0.409685);transform:scaleX(0.08)}19.15%{animation-timing-function:cubic-bezier(0.31033, 0.284058, 0.8, 0.733712);transform:scaleX(0.457104)}44.15%{animation-timing-function:cubic-bezier(0.4, 0.627035, 0.6, 0.902026);transform:scaleX(0.72796)}100%{transform:scaleX(0.08)}}@keyframes mat-progress-bar-background-scroll{to{transform:translateX(-8px)}}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyProgressBar, [{
                type: Component,
                args: [{
                  selector: 'mat-progress-bar',
                  exportAs: 'matProgressBar',
                  host: {
                    'role': 'progressbar',
                    'aria-valuemin': '0',
                    'aria-valuemax': '100',
                    // set tab index to -1 so screen readers will read the aria-label
                    // Note: there is a known issue with JAWS that does not read progressbar aria labels on FireFox
                    'tabindex': '-1',
                    '[attr.aria-valuenow]': '(mode === "indeterminate" || mode === "query") ? null : value',
                    '[attr.mode]': 'mode',
                    'class': 'mat-progress-bar',
                    '[class._mat-animation-noopable]': '_isNoopAnimation'
                  },
                  inputs: ['color'],
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  encapsulation: ViewEncapsulation.None,
                  template: "<!--\n  All children need to be hidden for screen readers in order to support ChromeVox.\n  More context in the issue: https://github.com/angular/components/issues/22165.\n-->\n<div aria-hidden=\"true\">\n  <svg width=\"100%\" height=\"4\" focusable=\"false\" class=\"mat-progress-bar-background mat-progress-bar-element\">\n    <defs>\n      <pattern [id]=\"progressbarId\" x=\"4\" y=\"0\" width=\"8\" height=\"4\" patternUnits=\"userSpaceOnUse\">\n        <circle cx=\"2\" cy=\"2\" r=\"2\"/>\n      </pattern>\n    </defs>\n    <rect [attr.fill]=\"_rectangleFillValue\" width=\"100%\" height=\"100%\"/>\n  </svg>\n  <!--\n    The background div is named as such because it appears below the other divs and is not sized based\n    on values.\n  -->\n  <div class=\"mat-progress-bar-buffer mat-progress-bar-element\" [ngStyle]=\"_bufferTransform()\"></div>\n  <div class=\"mat-progress-bar-primary mat-progress-bar-fill mat-progress-bar-element\" [ngStyle]=\"_primaryTransform()\" #primaryValueBar></div>\n  <div class=\"mat-progress-bar-secondary mat-progress-bar-fill mat-progress-bar-element\"></div>\n</div>\n",
                  styles: [".mat-progress-bar{display:block;height:4px;overflow:hidden;position:relative;transition:opacity 250ms linear;width:100%}.mat-progress-bar._mat-animation-noopable{transition:none !important;animation:none !important}.mat-progress-bar .mat-progress-bar-element,.mat-progress-bar .mat-progress-bar-fill::after{height:100%;position:absolute;width:100%}.mat-progress-bar .mat-progress-bar-background{width:calc(100% + 10px)}.cdk-high-contrast-active .mat-progress-bar .mat-progress-bar-background{display:none}.mat-progress-bar .mat-progress-bar-buffer{transform-origin:top left;transition:transform 250ms ease}.cdk-high-contrast-active .mat-progress-bar .mat-progress-bar-buffer{border-top:solid 5px;opacity:.5}.mat-progress-bar .mat-progress-bar-secondary{display:none}.mat-progress-bar .mat-progress-bar-fill{animation:none;transform-origin:top left;transition:transform 250ms ease}.cdk-high-contrast-active .mat-progress-bar .mat-progress-bar-fill{border-top:solid 4px}.mat-progress-bar .mat-progress-bar-fill::after{animation:none;content:\"\";display:inline-block;left:0}.mat-progress-bar[dir=rtl],[dir=rtl] .mat-progress-bar{transform:rotateY(180deg)}.mat-progress-bar[mode=query]{transform:rotateZ(180deg)}.mat-progress-bar[mode=query][dir=rtl],[dir=rtl] .mat-progress-bar[mode=query]{transform:rotateZ(180deg) rotateY(180deg)}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-fill,.mat-progress-bar[mode=query] .mat-progress-bar-fill{transition:none}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary,.mat-progress-bar[mode=query] .mat-progress-bar-primary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-translate 2000ms infinite linear;left:-145.166611%}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-primary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-scale 2000ms infinite linear}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary,.mat-progress-bar[mode=query] .mat-progress-bar-secondary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-translate 2000ms infinite linear;left:-54.888891%;display:block}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-secondary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-scale 2000ms infinite linear}.mat-progress-bar[mode=buffer] .mat-progress-bar-background{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-background-scroll 250ms infinite linear;display:block}.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-buffer,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-background{animation:none;transition-duration:1ms}@keyframes mat-progress-bar-primary-indeterminate-translate{0%{transform:translateX(0)}20%{animation-timing-function:cubic-bezier(0.5, 0, 0.701732, 0.495819);transform:translateX(0)}59.15%{animation-timing-function:cubic-bezier(0.302435, 0.381352, 0.55, 0.956352);transform:translateX(83.67142%)}100%{transform:translateX(200.611057%)}}@keyframes mat-progress-bar-primary-indeterminate-scale{0%{transform:scaleX(0.08)}36.65%{animation-timing-function:cubic-bezier(0.334731, 0.12482, 0.785844, 1);transform:scaleX(0.08)}69.15%{animation-timing-function:cubic-bezier(0.06, 0.11, 0.6, 1);transform:scaleX(0.661479)}100%{transform:scaleX(0.08)}}@keyframes mat-progress-bar-secondary-indeterminate-translate{0%{animation-timing-function:cubic-bezier(0.15, 0, 0.515058, 0.409685);transform:translateX(0)}25%{animation-timing-function:cubic-bezier(0.31033, 0.284058, 0.8, 0.733712);transform:translateX(37.651913%)}48.35%{animation-timing-function:cubic-bezier(0.4, 0.627035, 0.6, 0.902026);transform:translateX(84.386165%)}100%{transform:translateX(160.277782%)}}@keyframes mat-progress-bar-secondary-indeterminate-scale{0%{animation-timing-function:cubic-bezier(0.15, 0, 0.515058, 0.409685);transform:scaleX(0.08)}19.15%{animation-timing-function:cubic-bezier(0.31033, 0.284058, 0.8, 0.733712);transform:scaleX(0.457104)}44.15%{animation-timing-function:cubic-bezier(0.4, 0.627035, 0.6, 0.902026);transform:scaleX(0.72796)}100%{transform:scaleX(0.08)}}@keyframes mat-progress-bar-background-scroll{to{transform:translateX(-8px)}}"]
                }]
              }], function () {
                return [{
                  type: i0.ElementRef
                }, {
                  type: i0.NgZone
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_PROGRESS_BAR_LOCATION]
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_PROGRESS_BAR_DEFAULT_OPTIONS]
                  }]
                }, {
                  type: i0.ChangeDetectorRef
                }];
              }, {
                value: [{
                  type: Input
                }],
                bufferValue: [{
                  type: Input
                }],
                _primaryValueBar: [{
                  type: ViewChild,
                  args: ['primaryValueBar']
                }],
                animationEnd: [{
                  type: Output
                }],
                mode: [{
                  type: Input
                }]
              });
            })();
            /** Clamps a value to be between two numbers, by default 0 and 100. */
            function clamp(v, min = 0, max = 100) {
              return Math.max(min, Math.min(max, v));
            }

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            /**
             * @deprecated Use `MatProgressBarModule` from `@angular/material/progress-bar` instead. See https://material.angular.io/guide/mdc-migration for information about migrating.
             * @breaking-change 17.0.0
             */
            class MatLegacyProgressBarModule {} exports('MatLegacyProgressBarModule', MatLegacyProgressBarModule);
            MatLegacyProgressBarModule.ɵfac = function MatLegacyProgressBarModule_Factory(t) {
              return new (t || MatLegacyProgressBarModule)();
            };
            MatLegacyProgressBarModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatLegacyProgressBarModule
            });
            MatLegacyProgressBarModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              imports: [CommonModule, MatCommonModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatLegacyProgressBarModule, [{
                type: NgModule,
                args: [{
                  imports: [CommonModule, MatCommonModule],
                  exports: [MatLegacyProgressBar, MatCommonModule],
                  declarations: [MatLegacyProgressBar]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-legacy-progress-bar.js.map
