/* esm-bundle - @angular/material/radio@15.2.9 - Ivy - system format - es2020 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/material/core', '@angular/cdk/a11y', '@angular/cdk/coercion', '@angular/cdk/collections', '@angular/platform-browser/animations', '@angular/forms', '@angular/common'], (function (exports) {
    'use strict';
    var forwardRef, InjectionToken, i0, Directive, Output, Input, ViewChild, ContentChildren, Component, ViewEncapsulation, ChangeDetectionStrategy, Optional, Inject, Attribute, NgModule, EventEmitter, mixinDisableRipple, mixinTabIndex, i3, MatCommonModule, MatRippleModule, i1, coerceBooleanProperty, coerceNumberProperty, i2, ANIMATION_MODULE_TYPE, NG_VALUE_ACCESSOR, CommonModule;
    return {
        setters: [function (module) {
            forwardRef = module.forwardRef;
            InjectionToken = module.InjectionToken;
            i0 = module;
            Directive = module.Directive;
            Output = module.Output;
            Input = module.Input;
            ViewChild = module.ViewChild;
            ContentChildren = module.ContentChildren;
            Component = module.Component;
            ViewEncapsulation = module.ViewEncapsulation;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            Optional = module.Optional;
            Inject = module.Inject;
            Attribute = module.Attribute;
            NgModule = module.NgModule;
            EventEmitter = module.EventEmitter;
        }, function (module) {
            mixinDisableRipple = module.mixinDisableRipple;
            mixinTabIndex = module.mixinTabIndex;
            i3 = module;
            MatCommonModule = module.MatCommonModule;
            MatRippleModule = module.MatRippleModule;
        }, function (module) {
            i1 = module;
        }, function (module) {
            coerceBooleanProperty = module.coerceBooleanProperty;
            coerceNumberProperty = module.coerceNumberProperty;
        }, function (module) {
            i2 = module;
        }, function (module) {
            ANIMATION_MODULE_TYPE = module.ANIMATION_MODULE_TYPE;
        }, function (module) {
            NG_VALUE_ACCESSOR = module.NG_VALUE_ACCESSOR;
        }, function (module) {
            CommonModule = module.CommonModule;
        }],
        execute: (function () {

            exports('MAT_RADIO_DEFAULT_OPTIONS_FACTORY', MAT_RADIO_DEFAULT_OPTIONS_FACTORY);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            // Increasing integer for generating unique ids for radio components.
            const _c0 = ["input"];
            const _c1 = ["*"];
            let nextUniqueId = 0;
            /** Change event object emitted by radio button and radio group. */
            class MatRadioChange {
              constructor( /** The radio button that emits the change event. */
              source, /** The value of the radio button. */
              value) {
                this.source = source;
                this.value = value;
              }
            } exports('MatRadioChange', MatRadioChange);
            /**
             * Provider Expression that allows mat-radio-group to register as a ControlValueAccessor. This
             * allows it to support [(ngModel)] and ngControl.
             * @docs-private
             */
            const MAT_RADIO_GROUP_CONTROL_VALUE_ACCESSOR = exports('MAT_RADIO_GROUP_CONTROL_VALUE_ACCESSOR', {
              provide: NG_VALUE_ACCESSOR,
              useExisting: forwardRef(() => MatRadioGroup),
              multi: true
            });
            /**
             * Injection token that can be used to inject instances of `MatRadioGroup`. It serves as
             * alternative token to the actual `MatRadioGroup` class which could cause unnecessary
             * retention of the class and its component metadata.
             */
            const MAT_RADIO_GROUP = exports('MAT_RADIO_GROUP', new InjectionToken('MatRadioGroup'));
            const MAT_RADIO_DEFAULT_OPTIONS = exports('MAT_RADIO_DEFAULT_OPTIONS', new InjectionToken('mat-radio-default-options', {
              providedIn: 'root',
              factory: MAT_RADIO_DEFAULT_OPTIONS_FACTORY
            }));
            function MAT_RADIO_DEFAULT_OPTIONS_FACTORY() {
              return {
                color: 'accent'
              };
            }
            /**
             * Base class with all of the `MatRadioGroup` functionality.
             * @docs-private
             */
            class _MatRadioGroupBase {
              /** Name of the radio button group. All radio buttons inside this group will use this name. */
              get name() {
                return this._name;
              }
              set name(value) {
                this._name = value;
                this._updateRadioButtonNames();
              }
              /** Whether the labels should appear after or before the radio-buttons. Defaults to 'after' */
              get labelPosition() {
                return this._labelPosition;
              }
              set labelPosition(v) {
                this._labelPosition = v === 'before' ? 'before' : 'after';
                this._markRadiosForCheck();
              }
              /**
               * Value for the radio-group. Should equal the value of the selected radio button if there is
               * a corresponding radio button with a matching value. If there is not such a corresponding
               * radio button, this value persists to be applied in case a new radio button is added with a
               * matching value.
               */
              get value() {
                return this._value;
              }
              set value(newValue) {
                if (this._value !== newValue) {
                  // Set this before proceeding to ensure no circular loop occurs with selection.
                  this._value = newValue;
                  this._updateSelectedRadioFromValue();
                  this._checkSelectedRadioButton();
                }
              }
              _checkSelectedRadioButton() {
                if (this._selected && !this._selected.checked) {
                  this._selected.checked = true;
                }
              }
              /**
               * The currently selected radio button. If set to a new radio button, the radio group value
               * will be updated to match the new selected button.
               */
              get selected() {
                return this._selected;
              }
              set selected(selected) {
                this._selected = selected;
                this.value = selected ? selected.value : null;
                this._checkSelectedRadioButton();
              }
              /** Whether the radio group is disabled */
              get disabled() {
                return this._disabled;
              }
              set disabled(value) {
                this._disabled = coerceBooleanProperty(value);
                this._markRadiosForCheck();
              }
              /** Whether the radio group is required */
              get required() {
                return this._required;
              }
              set required(value) {
                this._required = coerceBooleanProperty(value);
                this._markRadiosForCheck();
              }
              constructor(_changeDetector) {
                this._changeDetector = _changeDetector;
                /** Selected value for the radio group. */
                this._value = null;
                /** The HTML name attribute applied to radio buttons in this group. */
                this._name = `mat-radio-group-${nextUniqueId++}`;
                /** The currently selected radio button. Should match value. */
                this._selected = null;
                /** Whether the `value` has been set to its initial value. */
                this._isInitialized = false;
                /** Whether the labels should appear after or before the radio-buttons. Defaults to 'after' */
                this._labelPosition = 'after';
                /** Whether the radio group is disabled. */
                this._disabled = false;
                /** Whether the radio group is required. */
                this._required = false;
                /** The method to be called in order to update ngModel */
                this._controlValueAccessorChangeFn = () => {};
                /**
                 * onTouch function registered via registerOnTouch (ControlValueAccessor).
                 * @docs-private
                 */
                this.onTouched = () => {};
                /**
                 * Event emitted when the group value changes.
                 * Change events are only emitted when the value changes due to user interaction with
                 * a radio button (the same behavior as `<input type-"radio">`).
                 */
                this.change = new EventEmitter();
              }
              /**
               * Initialize properties once content children are available.
               * This allows us to propagate relevant attributes to associated buttons.
               */
              ngAfterContentInit() {
                // Mark this component as initialized in AfterContentInit because the initial value can
                // possibly be set by NgModel on MatRadioGroup, and it is possible that the OnInit of the
                // NgModel occurs *after* the OnInit of the MatRadioGroup.
                this._isInitialized = true;
              }
              /**
               * Mark this group as being "touched" (for ngModel). Meant to be called by the contained
               * radio buttons upon their blur.
               */
              _touch() {
                if (this.onTouched) {
                  this.onTouched();
                }
              }
              _updateRadioButtonNames() {
                if (this._radios) {
                  this._radios.forEach(radio => {
                    radio.name = this.name;
                    radio._markForCheck();
                  });
                }
              }
              /** Updates the `selected` radio button from the internal _value state. */
              _updateSelectedRadioFromValue() {
                // If the value already matches the selected radio, do nothing.
                const isAlreadySelected = this._selected !== null && this._selected.value === this._value;
                if (this._radios && !isAlreadySelected) {
                  this._selected = null;
                  this._radios.forEach(radio => {
                    radio.checked = this.value === radio.value;
                    if (radio.checked) {
                      this._selected = radio;
                    }
                  });
                }
              }
              /** Dispatch change event with current selection and group value. */
              _emitChangeEvent() {
                if (this._isInitialized) {
                  this.change.emit(new MatRadioChange(this._selected, this._value));
                }
              }
              _markRadiosForCheck() {
                if (this._radios) {
                  this._radios.forEach(radio => radio._markForCheck());
                }
              }
              /**
               * Sets the model value. Implemented as part of ControlValueAccessor.
               * @param value
               */
              writeValue(value) {
                this.value = value;
                this._changeDetector.markForCheck();
              }
              /**
               * Registers a callback to be triggered when the model value changes.
               * Implemented as part of ControlValueAccessor.
               * @param fn Callback to be registered.
               */
              registerOnChange(fn) {
                this._controlValueAccessorChangeFn = fn;
              }
              /**
               * Registers a callback to be triggered when the control is touched.
               * Implemented as part of ControlValueAccessor.
               * @param fn Callback to be registered.
               */
              registerOnTouched(fn) {
                this.onTouched = fn;
              }
              /**
               * Sets the disabled state of the control. Implemented as a part of ControlValueAccessor.
               * @param isDisabled Whether the control should be disabled.
               */
              setDisabledState(isDisabled) {
                this.disabled = isDisabled;
                this._changeDetector.markForCheck();
              }
            } exports('_MatRadioGroupBase', _MatRadioGroupBase);
            _MatRadioGroupBase.ɵfac = function _MatRadioGroupBase_Factory(t) {
              return new (t || _MatRadioGroupBase)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef));
            };
            _MatRadioGroupBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatRadioGroupBase,
              inputs: {
                color: "color",
                name: "name",
                labelPosition: "labelPosition",
                value: "value",
                selected: "selected",
                disabled: "disabled",
                required: "required"
              },
              outputs: {
                change: "change"
              }
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatRadioGroupBase, [{
                type: Directive
              }], function () {
                return [{
                  type: i0.ChangeDetectorRef
                }];
              }, {
                change: [{
                  type: Output
                }],
                color: [{
                  type: Input
                }],
                name: [{
                  type: Input
                }],
                labelPosition: [{
                  type: Input
                }],
                value: [{
                  type: Input
                }],
                selected: [{
                  type: Input
                }],
                disabled: [{
                  type: Input
                }],
                required: [{
                  type: Input
                }]
              });
            })();
            // Boilerplate for applying mixins to MatRadioButton.
            /** @docs-private */
            class MatRadioButtonBase {
              constructor(_elementRef) {
                this._elementRef = _elementRef;
              }
            }
            const _MatRadioButtonMixinBase = mixinDisableRipple(mixinTabIndex(MatRadioButtonBase));
            /**
             * Base class with all of the `MatRadioButton` functionality.
             * @docs-private
             */
            class _MatRadioButtonBase extends _MatRadioButtonMixinBase {
              /** Whether this radio button is checked. */
              get checked() {
                return this._checked;
              }
              set checked(value) {
                const newCheckedState = coerceBooleanProperty(value);
                if (this._checked !== newCheckedState) {
                  this._checked = newCheckedState;
                  if (newCheckedState && this.radioGroup && this.radioGroup.value !== this.value) {
                    this.radioGroup.selected = this;
                  } else if (!newCheckedState && this.radioGroup && this.radioGroup.value === this.value) {
                    // When unchecking the selected radio button, update the selected radio
                    // property on the group.
                    this.radioGroup.selected = null;
                  }
                  if (newCheckedState) {
                    // Notify all radio buttons with the same name to un-check.
                    this._radioDispatcher.notify(this.id, this.name);
                  }
                  this._changeDetector.markForCheck();
                }
              }
              /** The value of this radio button. */
              get value() {
                return this._value;
              }
              set value(value) {
                if (this._value !== value) {
                  this._value = value;
                  if (this.radioGroup !== null) {
                    if (!this.checked) {
                      // Update checked when the value changed to match the radio group's value
                      this.checked = this.radioGroup.value === value;
                    }
                    if (this.checked) {
                      this.radioGroup.selected = this;
                    }
                  }
                }
              }
              /** Whether the label should appear after or before the radio button. Defaults to 'after' */
              get labelPosition() {
                return this._labelPosition || this.radioGroup && this.radioGroup.labelPosition || 'after';
              }
              set labelPosition(value) {
                this._labelPosition = value;
              }
              /** Whether the radio button is disabled. */
              get disabled() {
                return this._disabled || this.radioGroup !== null && this.radioGroup.disabled;
              }
              set disabled(value) {
                this._setDisabled(coerceBooleanProperty(value));
              }
              /** Whether the radio button is required. */
              get required() {
                return this._required || this.radioGroup && this.radioGroup.required;
              }
              set required(value) {
                this._required = coerceBooleanProperty(value);
              }
              /** Theme color of the radio button. */
              get color() {
                // As per Material design specifications the selection control radio should use the accent color
                // palette by default. https://material.io/guidelines/components/selection-controls.html
                return this._color || this.radioGroup && this.radioGroup.color || this._providerOverride && this._providerOverride.color || 'accent';
              }
              set color(newValue) {
                this._color = newValue;
              }
              /** ID of the native input element inside `<mat-radio-button>` */
              get inputId() {
                return `${this.id || this._uniqueId}-input`;
              }
              constructor(radioGroup, elementRef, _changeDetector, _focusMonitor, _radioDispatcher, animationMode, _providerOverride, tabIndex) {
                super(elementRef);
                this._changeDetector = _changeDetector;
                this._focusMonitor = _focusMonitor;
                this._radioDispatcher = _radioDispatcher;
                this._providerOverride = _providerOverride;
                this._uniqueId = `mat-radio-${++nextUniqueId}`;
                /** The unique ID for the radio button. */
                this.id = this._uniqueId;
                /**
                 * Event emitted when the checked state of this radio button changes.
                 * Change events are only emitted when the value changes due to user interaction with
                 * the radio button (the same behavior as `<input type-"radio">`).
                 */
                this.change = new EventEmitter();
                /** Whether this radio is checked. */
                this._checked = false;
                /** Value assigned to this radio. */
                this._value = null;
                /** Unregister function for _radioDispatcher */
                this._removeUniqueSelectionListener = () => {};
                // Assertions. Ideally these should be stripped out by the compiler.
                // TODO(jelbourn): Assert that there's no name binding AND a parent radio group.
                this.radioGroup = radioGroup;
                this._noopAnimations = animationMode === 'NoopAnimations';
                if (tabIndex) {
                  this.tabIndex = coerceNumberProperty(tabIndex, 0);
                }
              }
              /** Focuses the radio button. */
              focus(options, origin) {
                if (origin) {
                  this._focusMonitor.focusVia(this._inputElement, origin, options);
                } else {
                  this._inputElement.nativeElement.focus(options);
                }
              }
              /**
               * Marks the radio button as needing checking for change detection.
               * This method is exposed because the parent radio group will directly
               * update bound properties of the radio button.
               */
              _markForCheck() {
                // When group value changes, the button will not be notified. Use `markForCheck` to explicit
                // update radio button's status
                this._changeDetector.markForCheck();
              }
              ngOnInit() {
                if (this.radioGroup) {
                  // If the radio is inside a radio group, determine if it should be checked
                  this.checked = this.radioGroup.value === this._value;
                  if (this.checked) {
                    this.radioGroup.selected = this;
                  }
                  // Copy name from parent radio group
                  this.name = this.radioGroup.name;
                }
                this._removeUniqueSelectionListener = this._radioDispatcher.listen((id, name) => {
                  if (id !== this.id && name === this.name) {
                    this.checked = false;
                  }
                });
              }
              ngDoCheck() {
                this._updateTabIndex();
              }
              ngAfterViewInit() {
                this._updateTabIndex();
                this._focusMonitor.monitor(this._elementRef, true).subscribe(focusOrigin => {
                  if (!focusOrigin && this.radioGroup) {
                    this.radioGroup._touch();
                  }
                });
              }
              ngOnDestroy() {
                this._focusMonitor.stopMonitoring(this._elementRef);
                this._removeUniqueSelectionListener();
              }
              /** Dispatch change event with current value. */
              _emitChangeEvent() {
                this.change.emit(new MatRadioChange(this, this._value));
              }
              _isRippleDisabled() {
                return this.disableRipple || this.disabled;
              }
              _onInputClick(event) {
                // We have to stop propagation for click events on the visual hidden input element.
                // By default, when a user clicks on a label element, a generated click event will be
                // dispatched on the associated input element. Since we are using a label element as our
                // root container, the click event on the `radio-button` will be executed twice.
                // The real click event will bubble up, and the generated click event also tries to bubble up.
                // This will lead to multiple click events.
                // Preventing bubbling for the second event will solve that issue.
                event.stopPropagation();
              }
              /** Triggered when the radio button receives an interaction from the user. */
              _onInputInteraction(event) {
                // We always have to stop propagation on the change event.
                // Otherwise the change event, from the input element, will bubble up and
                // emit its event object to the `change` output.
                event.stopPropagation();
                if (!this.checked && !this.disabled) {
                  const groupValueChanged = this.radioGroup && this.value !== this.radioGroup.value;
                  this.checked = true;
                  this._emitChangeEvent();
                  if (this.radioGroup) {
                    this.radioGroup._controlValueAccessorChangeFn(this.value);
                    if (groupValueChanged) {
                      this.radioGroup._emitChangeEvent();
                    }
                  }
                }
              }
              /** Triggered when the user clicks on the touch target. */
              _onTouchTargetClick(event) {
                this._onInputInteraction(event);
                if (!this.disabled) {
                  // Normally the input should be focused already, but if the click
                  // comes from the touch target, then we might have to focus it ourselves.
                  this._inputElement.nativeElement.focus();
                }
              }
              /** Sets the disabled state and marks for check if a change occurred. */
              _setDisabled(value) {
                if (this._disabled !== value) {
                  this._disabled = value;
                  this._changeDetector.markForCheck();
                }
              }
              /** Gets the tabindex for the underlying input element. */
              _updateTabIndex() {
                const group = this.radioGroup;
                let value;
                // Implement a roving tabindex if the button is inside a group. For most cases this isn't
                // necessary, because the browser handles the tab order for inputs inside a group automatically,
                // but we need an explicitly higher tabindex for the selected button in order for things like
                // the focus trap to pick it up correctly.
                if (!group || !group.selected || this.disabled) {
                  value = this.tabIndex;
                } else {
                  value = group.selected === this ? this.tabIndex : -1;
                }
                if (value !== this._previousTabIndex) {
                  // We have to set the tabindex directly on the DOM node, because it depends on
                  // the selected state which is prone to "changed after checked errors".
                  const input = this._inputElement?.nativeElement;
                  if (input) {
                    input.setAttribute('tabindex', value + '');
                    this._previousTabIndex = value;
                  }
                }
              }
            } exports('_MatRadioButtonBase', _MatRadioButtonBase);
            _MatRadioButtonBase.ɵfac = function _MatRadioButtonBase_Factory(t) {
              i0.ɵɵinvalidFactory();
            };
            _MatRadioButtonBase.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: _MatRadioButtonBase,
              viewQuery: function _MatRadioButtonBase_Query(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵviewQuery(_c0, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._inputElement = _t.first);
                }
              },
              inputs: {
                id: "id",
                name: "name",
                ariaLabel: ["aria-label", "ariaLabel"],
                ariaLabelledby: ["aria-labelledby", "ariaLabelledby"],
                ariaDescribedby: ["aria-describedby", "ariaDescribedby"],
                checked: "checked",
                value: "value",
                labelPosition: "labelPosition",
                disabled: "disabled",
                required: "required",
                color: "color"
              },
              outputs: {
                change: "change"
              },
              features: [i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(_MatRadioButtonBase, [{
                type: Directive
              }], function () {
                return [{
                  type: _MatRadioGroupBase
                }, {
                  type: i0.ElementRef
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: i1.FocusMonitor
                }, {
                  type: i2.UniqueSelectionDispatcher
                }, {
                  type: undefined
                }, {
                  type: undefined
                }, {
                  type: undefined
                }];
              }, {
                id: [{
                  type: Input
                }],
                name: [{
                  type: Input
                }],
                ariaLabel: [{
                  type: Input,
                  args: ['aria-label']
                }],
                ariaLabelledby: [{
                  type: Input,
                  args: ['aria-labelledby']
                }],
                ariaDescribedby: [{
                  type: Input,
                  args: ['aria-describedby']
                }],
                checked: [{
                  type: Input
                }],
                value: [{
                  type: Input
                }],
                labelPosition: [{
                  type: Input
                }],
                disabled: [{
                  type: Input
                }],
                required: [{
                  type: Input
                }],
                color: [{
                  type: Input
                }],
                change: [{
                  type: Output
                }],
                _inputElement: [{
                  type: ViewChild,
                  args: ['input']
                }]
              });
            })();
            /**
             * A group of radio buttons. May contain one or more `<mat-radio-button>` elements.
             */
            class MatRadioGroup extends _MatRadioGroupBase {} exports('MatRadioGroup', MatRadioGroup);
            MatRadioGroup.ɵfac = /* @__PURE__ */function () {
              let ɵMatRadioGroup_BaseFactory;
              return function MatRadioGroup_Factory(t) {
                return (ɵMatRadioGroup_BaseFactory || (ɵMatRadioGroup_BaseFactory = i0.ɵɵgetInheritedFactory(MatRadioGroup)))(t || MatRadioGroup);
              };
            }();
            MatRadioGroup.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatRadioGroup,
              selectors: [["mat-radio-group"]],
              contentQueries: function MatRadioGroup_ContentQueries(rf, ctx, dirIndex) {
                if (rf & 1) {
                  i0.ɵɵcontentQuery(dirIndex, MatRadioButton, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._radios = _t);
                }
              },
              hostAttrs: ["role", "radiogroup", 1, "mat-mdc-radio-group"],
              exportAs: ["matRadioGroup"],
              features: [i0.ɵɵProvidersFeature([MAT_RADIO_GROUP_CONTROL_VALUE_ACCESSOR, {
                provide: MAT_RADIO_GROUP,
                useExisting: MatRadioGroup
              }]), i0.ɵɵInheritDefinitionFeature]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatRadioGroup, [{
                type: Directive,
                args: [{
                  selector: 'mat-radio-group',
                  exportAs: 'matRadioGroup',
                  providers: [MAT_RADIO_GROUP_CONTROL_VALUE_ACCESSOR, {
                    provide: MAT_RADIO_GROUP,
                    useExisting: MatRadioGroup
                  }],
                  host: {
                    'role': 'radiogroup',
                    'class': 'mat-mdc-radio-group'
                  }
                }]
              }], null, {
                _radios: [{
                  type: ContentChildren,
                  args: [forwardRef(() => MatRadioButton), {
                    descendants: true
                  }]
                }]
              });
            })();
            class MatRadioButton extends _MatRadioButtonBase {
              constructor(radioGroup, elementRef, _changeDetector, _focusMonitor, _radioDispatcher, animationMode, _providerOverride, tabIndex) {
                super(radioGroup, elementRef, _changeDetector, _focusMonitor, _radioDispatcher, animationMode, _providerOverride, tabIndex);
              }
            } exports('MatRadioButton', MatRadioButton);
            MatRadioButton.ɵfac = function MatRadioButton_Factory(t) {
              return new (t || MatRadioButton)(i0.ɵɵdirectiveInject(MAT_RADIO_GROUP, 8), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1.FocusMonitor), i0.ɵɵdirectiveInject(i2.UniqueSelectionDispatcher), i0.ɵɵdirectiveInject(ANIMATION_MODULE_TYPE, 8), i0.ɵɵdirectiveInject(MAT_RADIO_DEFAULT_OPTIONS, 8), i0.ɵɵinjectAttribute('tabindex'));
            };
            MatRadioButton.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatRadioButton,
              selectors: [["mat-radio-button"]],
              hostAttrs: [1, "mat-mdc-radio-button"],
              hostVars: 15,
              hostBindings: function MatRadioButton_HostBindings(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵlistener("focus", function MatRadioButton_focus_HostBindingHandler() {
                    return ctx._inputElement.nativeElement.focus();
                  });
                }
                if (rf & 2) {
                  i0.ɵɵattribute("id", ctx.id)("tabindex", null)("aria-label", null)("aria-labelledby", null)("aria-describedby", null);
                  i0.ɵɵclassProp("mat-primary", ctx.color === "primary")("mat-accent", ctx.color === "accent")("mat-warn", ctx.color === "warn")("mat-mdc-radio-checked", ctx.checked)("_mat-animation-noopable", ctx._noopAnimations);
                }
              },
              inputs: {
                disableRipple: "disableRipple",
                tabIndex: "tabIndex"
              },
              exportAs: ["matRadioButton"],
              features: [i0.ɵɵInheritDefinitionFeature],
              ngContentSelectors: _c1,
              decls: 13,
              vars: 17,
              consts: [[1, "mdc-form-field"], ["formField", ""], [1, "mdc-radio"], [1, "mat-mdc-radio-touch-target", 3, "click"], ["type", "radio", 1, "mdc-radio__native-control", 3, "id", "checked", "disabled", "required", "change"], ["input", ""], [1, "mdc-radio__background"], [1, "mdc-radio__outer-circle"], [1, "mdc-radio__inner-circle"], ["mat-ripple", "", 1, "mat-radio-ripple", "mat-mdc-focus-indicator", 3, "matRippleTrigger", "matRippleDisabled", "matRippleCentered"], [1, "mat-ripple-element", "mat-radio-persistent-ripple"], [3, "for"]],
              template: function MatRadioButton_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef();
                  i0.ɵɵelementStart(0, "div", 0, 1)(2, "div", 2)(3, "div", 3);
                  i0.ɵɵlistener("click", function MatRadioButton_Template_div_click_3_listener($event) {
                    return ctx._onTouchTargetClick($event);
                  });
                  i0.ɵɵelementEnd();
                  i0.ɵɵelementStart(4, "input", 4, 5);
                  i0.ɵɵlistener("change", function MatRadioButton_Template_input_change_4_listener($event) {
                    return ctx._onInputInteraction($event);
                  });
                  i0.ɵɵelementEnd();
                  i0.ɵɵelementStart(6, "div", 6);
                  i0.ɵɵelement(7, "div", 7)(8, "div", 8);
                  i0.ɵɵelementEnd();
                  i0.ɵɵelementStart(9, "div", 9);
                  i0.ɵɵelement(10, "div", 10);
                  i0.ɵɵelementEnd()();
                  i0.ɵɵelementStart(11, "label", 11);
                  i0.ɵɵprojection(12);
                  i0.ɵɵelementEnd()();
                }
                if (rf & 2) {
                  const _r0 = i0.ɵɵreference(1);
                  i0.ɵɵclassProp("mdc-form-field--align-end", ctx.labelPosition == "before");
                  i0.ɵɵadvance(2);
                  i0.ɵɵclassProp("mdc-radio--disabled", ctx.disabled);
                  i0.ɵɵadvance(2);
                  i0.ɵɵproperty("id", ctx.inputId)("checked", ctx.checked)("disabled", ctx.disabled)("required", ctx.required);
                  i0.ɵɵattribute("name", ctx.name)("value", ctx.value)("aria-label", ctx.ariaLabel)("aria-labelledby", ctx.ariaLabelledby)("aria-describedby", ctx.ariaDescribedby);
                  i0.ɵɵadvance(5);
                  i0.ɵɵproperty("matRippleTrigger", _r0)("matRippleDisabled", ctx._isRippleDisabled())("matRippleCentered", true);
                  i0.ɵɵadvance(2);
                  i0.ɵɵproperty("for", ctx.inputId);
                }
              },
              dependencies: [i3.MatRipple],
              styles: [".mdc-radio{display:inline-block;position:relative;flex:0 0 auto;box-sizing:content-box;width:20px;height:20px;cursor:pointer;will-change:opacity,transform,border-color,color}.mdc-radio[hidden]{display:none}.mdc-radio__background{display:inline-block;position:relative;box-sizing:border-box;width:20px;height:20px}.mdc-radio__background::before{position:absolute;transform:scale(0, 0);border-radius:50%;opacity:0;pointer-events:none;content:\"\";transition:opacity 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1),transform 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1)}.mdc-radio__outer-circle{position:absolute;top:0;left:0;box-sizing:border-box;width:100%;height:100%;border-width:2px;border-style:solid;border-radius:50%;transition:border-color 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1)}.mdc-radio__inner-circle{position:absolute;top:0;left:0;box-sizing:border-box;width:100%;height:100%;transform:scale(0, 0);border-width:10px;border-style:solid;border-radius:50%;transition:transform 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1),border-color 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1)}.mdc-radio__native-control{position:absolute;margin:0;padding:0;opacity:0;cursor:inherit;z-index:1}.mdc-radio--touch{margin-top:4px;margin-bottom:4px;margin-right:4px;margin-left:4px}.mdc-radio--touch .mdc-radio__native-control{top:calc((40px - 48px) / 2);right:calc((40px - 48px) / 2);left:calc((40px - 48px) / 2);width:48px;height:48px}.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring{pointer-events:none;border:2px solid rgba(0,0,0,0);border-radius:6px;box-sizing:content-box;position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);height:100%;width:100%}@media screen and (forced-colors: active){.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring{border-color:CanvasText}}.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring::after,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring::after{content:\"\";border:2px solid rgba(0,0,0,0);border-radius:8px;display:block;position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);height:calc(100% + 4px);width:calc(100% + 4px)}@media screen and (forced-colors: active){.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring::after,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring::after{border-color:CanvasText}}.mdc-radio__native-control:checked+.mdc-radio__background,.mdc-radio__native-control:disabled+.mdc-radio__background{transition:opacity 120ms 0ms cubic-bezier(0, 0, 0.2, 1),transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__outer-circle,.mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__outer-circle{transition:border-color 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__inner-circle,.mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__inner-circle{transition:transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1),border-color 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio--disabled{cursor:default;pointer-events:none}.mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__inner-circle{transform:scale(0.5);transition:transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1),border-color 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio__native-control:disabled+.mdc-radio__background,[aria-disabled=true] .mdc-radio__native-control+.mdc-radio__background{cursor:default}.mdc-radio__native-control:focus+.mdc-radio__background::before{transform:scale(1);opacity:.12;transition:opacity 120ms 0ms cubic-bezier(0, 0, 0.2, 1),transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-form-field{display:inline-flex;align-items:center;vertical-align:middle}.mdc-form-field[hidden]{display:none}.mdc-form-field>label{margin-left:0;margin-right:auto;padding-left:4px;padding-right:0;order:0}[dir=rtl] .mdc-form-field>label,.mdc-form-field>label[dir=rtl]{margin-left:auto;margin-right:0}[dir=rtl] .mdc-form-field>label,.mdc-form-field>label[dir=rtl]{padding-left:0;padding-right:4px}.mdc-form-field--nowrap>label{text-overflow:ellipsis;overflow:hidden;white-space:nowrap}.mdc-form-field--align-end>label{margin-left:auto;margin-right:0;padding-left:0;padding-right:4px;order:-1}[dir=rtl] .mdc-form-field--align-end>label,.mdc-form-field--align-end>label[dir=rtl]{margin-left:0;margin-right:auto}[dir=rtl] .mdc-form-field--align-end>label,.mdc-form-field--align-end>label[dir=rtl]{padding-left:4px;padding-right:0}.mdc-form-field--space-between{justify-content:space-between}.mdc-form-field--space-between>label{margin:0}[dir=rtl] .mdc-form-field--space-between>label,.mdc-form-field--space-between>label[dir=rtl]{margin:0}.mat-mdc-radio-button{-webkit-tap-highlight-color:rgba(0,0,0,0)}.mat-mdc-radio-button .mdc-radio{padding:calc((var(--mdc-radio-state-layer-size, 40px) - 20px) / 2)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-disabled-selected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control+.mdc-radio__background .mdc-radio__inner-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-disabled-selected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:checked+.mdc-radio__background .mdc-radio__outer-circle{opacity:var(--mdc-radio-disabled-selected-icon-opacity, 0.38)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control+.mdc-radio__background .mdc-radio__inner-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__inner-circle{opacity:var(--mdc-radio-disabled-selected-icon-opacity, 0.38)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-disabled-unselected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{opacity:var(--mdc-radio-disabled-unselected-icon-opacity, 0.38)}.mat-mdc-radio-button .mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-focus-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle,.mat-mdc-radio-button .mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-focus-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-hover-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-hover-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:not(:disabled):active .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-pressed-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:not(:disabled):active .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-pressed-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:enabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-hover-icon-color, #000)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:enabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio:not(:disabled):active .mdc-radio__native-control:enabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-pressed-icon-color, #000)}.mat-mdc-radio-button .mdc-radio .mdc-radio__background::before{top:calc(-1 * (var(--mdc-radio-state-layer-size, 40px) - 20px) / 2);left:calc(-1 * (var(--mdc-radio-state-layer-size, 40px) - 20px) / 2);width:var(--mdc-radio-state-layer-size, 40px);height:var(--mdc-radio-state-layer-size, 40px)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control{top:calc((var(--mdc-radio-state-layer-size, 40px) - var(--mdc-radio-state-layer-size, 40px)) / 2);right:calc((var(--mdc-radio-state-layer-size, 40px) - var(--mdc-radio-state-layer-size, 40px)) / 2);left:calc((var(--mdc-radio-state-layer-size, 40px) - var(--mdc-radio-state-layer-size, 40px)) / 2);width:var(--mdc-radio-state-layer-size, 40px);height:var(--mdc-radio-state-layer-size, 40px)}.mat-mdc-radio-button .mdc-radio .mdc-radio__background::before{background-color:var(--mat-mdc-radio-ripple-color, transparent)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:not([disabled]):not(:focus)~.mdc-radio__background::before{opacity:.04;transform:scale(1)}.mat-mdc-radio-button.mat-mdc-radio-checked .mdc-radio__background::before{background-color:var(--mat-mdc-radio-checked-ripple-color, transparent)}.mat-mdc-radio-button.mat-mdc-radio-checked .mat-ripple-element{background-color:var(--mat-mdc-radio-checked-ripple-color, transparent)}.mat-mdc-radio-button .mat-radio-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none;border-radius:50%}.mat-mdc-radio-button .mat-radio-ripple .mat-ripple-element{opacity:.14}.mat-mdc-radio-button .mat-radio-ripple::before{border-radius:50%}.mat-mdc-radio-button._mat-animation-noopable .mdc-radio__background::before,.mat-mdc-radio-button._mat-animation-noopable .mdc-radio__outer-circle,.mat-mdc-radio-button._mat-animation-noopable .mdc-radio__inner-circle{transition:none !important}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:focus:enabled:not(:checked)~.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-focus-icon-color, black)}.mat-mdc-radio-button.cdk-focused .mat-mdc-focus-indicator::before{content:\"\"}.mat-mdc-radio-touch-target{position:absolute;top:50%;height:48px;left:50%;width:48px;transform:translate(-50%, -50%)}[dir=rtl] .mat-mdc-radio-touch-target{left:0;right:50%;transform:translate(50%, -50%)}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatRadioButton, [{
                type: Component,
                args: [{
                  selector: 'mat-radio-button',
                  host: {
                    'class': 'mat-mdc-radio-button',
                    '[attr.id]': 'id',
                    '[class.mat-primary]': 'color === "primary"',
                    '[class.mat-accent]': 'color === "accent"',
                    '[class.mat-warn]': 'color === "warn"',
                    '[class.mat-mdc-radio-checked]': 'checked',
                    '[class._mat-animation-noopable]': '_noopAnimations',
                    // Needs to be removed since it causes some a11y issues (see #21266).
                    '[attr.tabindex]': 'null',
                    '[attr.aria-label]': 'null',
                    '[attr.aria-labelledby]': 'null',
                    '[attr.aria-describedby]': 'null',
                    // Note: under normal conditions focus shouldn't land on this element, however it may be
                    // programmatically set, for example inside of a focus trap, in this case we want to forward
                    // the focus to the native element.
                    '(focus)': '_inputElement.nativeElement.focus()'
                  },
                  inputs: ['disableRipple', 'tabIndex'],
                  exportAs: 'matRadioButton',
                  encapsulation: ViewEncapsulation.None,
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  template: "<div class=\"mdc-form-field\" #formField\n     [class.mdc-form-field--align-end]=\"labelPosition == 'before'\">\n  <div class=\"mdc-radio\" [class.mdc-radio--disabled]=\"disabled\">\n    <!-- Render this element first so the input is on top. -->\n    <div class=\"mat-mdc-radio-touch-target\" (click)=\"_onTouchTargetClick($event)\"></div>\n    <input #input class=\"mdc-radio__native-control\" type=\"radio\"\n           [id]=\"inputId\"\n           [checked]=\"checked\"\n           [disabled]=\"disabled\"\n           [attr.name]=\"name\"\n           [attr.value]=\"value\"\n           [required]=\"required\"\n           [attr.aria-label]=\"ariaLabel\"\n           [attr.aria-labelledby]=\"ariaLabelledby\"\n           [attr.aria-describedby]=\"ariaDescribedby\"\n           (change)=\"_onInputInteraction($event)\">\n    <div class=\"mdc-radio__background\">\n      <div class=\"mdc-radio__outer-circle\"></div>\n      <div class=\"mdc-radio__inner-circle\"></div>\n    </div>\n    <div mat-ripple class=\"mat-radio-ripple mat-mdc-focus-indicator\"\n         [matRippleTrigger]=\"formField\"\n         [matRippleDisabled]=\"_isRippleDisabled()\"\n         [matRippleCentered]=\"true\">\n      <div class=\"mat-ripple-element mat-radio-persistent-ripple\"></div>\n    </div>\n  </div>\n  <label [for]=\"inputId\">\n    <ng-content></ng-content>\n  </label>\n</div>\n",
                  styles: [".mdc-radio{display:inline-block;position:relative;flex:0 0 auto;box-sizing:content-box;width:20px;height:20px;cursor:pointer;will-change:opacity,transform,border-color,color}.mdc-radio[hidden]{display:none}.mdc-radio__background{display:inline-block;position:relative;box-sizing:border-box;width:20px;height:20px}.mdc-radio__background::before{position:absolute;transform:scale(0, 0);border-radius:50%;opacity:0;pointer-events:none;content:\"\";transition:opacity 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1),transform 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1)}.mdc-radio__outer-circle{position:absolute;top:0;left:0;box-sizing:border-box;width:100%;height:100%;border-width:2px;border-style:solid;border-radius:50%;transition:border-color 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1)}.mdc-radio__inner-circle{position:absolute;top:0;left:0;box-sizing:border-box;width:100%;height:100%;transform:scale(0, 0);border-width:10px;border-style:solid;border-radius:50%;transition:transform 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1),border-color 120ms 0ms cubic-bezier(0.4, 0, 0.6, 1)}.mdc-radio__native-control{position:absolute;margin:0;padding:0;opacity:0;cursor:inherit;z-index:1}.mdc-radio--touch{margin-top:4px;margin-bottom:4px;margin-right:4px;margin-left:4px}.mdc-radio--touch .mdc-radio__native-control{top:calc((40px - 48px) / 2);right:calc((40px - 48px) / 2);left:calc((40px - 48px) / 2);width:48px;height:48px}.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring{pointer-events:none;border:2px solid rgba(0,0,0,0);border-radius:6px;box-sizing:content-box;position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);height:100%;width:100%}@media screen and (forced-colors: active){.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring{border-color:CanvasText}}.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring::after,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring::after{content:\"\";border:2px solid rgba(0,0,0,0);border-radius:8px;display:block;position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);height:calc(100% + 4px);width:calc(100% + 4px)}@media screen and (forced-colors: active){.mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__focus-ring::after,.mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__focus-ring::after{border-color:CanvasText}}.mdc-radio__native-control:checked+.mdc-radio__background,.mdc-radio__native-control:disabled+.mdc-radio__background{transition:opacity 120ms 0ms cubic-bezier(0, 0, 0.2, 1),transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__outer-circle,.mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__outer-circle{transition:border-color 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__inner-circle,.mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__inner-circle{transition:transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1),border-color 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio--disabled{cursor:default;pointer-events:none}.mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__inner-circle{transform:scale(0.5);transition:transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1),border-color 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-radio__native-control:disabled+.mdc-radio__background,[aria-disabled=true] .mdc-radio__native-control+.mdc-radio__background{cursor:default}.mdc-radio__native-control:focus+.mdc-radio__background::before{transform:scale(1);opacity:.12;transition:opacity 120ms 0ms cubic-bezier(0, 0, 0.2, 1),transform 120ms 0ms cubic-bezier(0, 0, 0.2, 1)}.mdc-form-field{display:inline-flex;align-items:center;vertical-align:middle}.mdc-form-field[hidden]{display:none}.mdc-form-field>label{margin-left:0;margin-right:auto;padding-left:4px;padding-right:0;order:0}[dir=rtl] .mdc-form-field>label,.mdc-form-field>label[dir=rtl]{margin-left:auto;margin-right:0}[dir=rtl] .mdc-form-field>label,.mdc-form-field>label[dir=rtl]{padding-left:0;padding-right:4px}.mdc-form-field--nowrap>label{text-overflow:ellipsis;overflow:hidden;white-space:nowrap}.mdc-form-field--align-end>label{margin-left:auto;margin-right:0;padding-left:0;padding-right:4px;order:-1}[dir=rtl] .mdc-form-field--align-end>label,.mdc-form-field--align-end>label[dir=rtl]{margin-left:0;margin-right:auto}[dir=rtl] .mdc-form-field--align-end>label,.mdc-form-field--align-end>label[dir=rtl]{padding-left:4px;padding-right:0}.mdc-form-field--space-between{justify-content:space-between}.mdc-form-field--space-between>label{margin:0}[dir=rtl] .mdc-form-field--space-between>label,.mdc-form-field--space-between>label[dir=rtl]{margin:0}.mat-mdc-radio-button{-webkit-tap-highlight-color:rgba(0,0,0,0)}.mat-mdc-radio-button .mdc-radio{padding:calc((var(--mdc-radio-state-layer-size, 40px) - 20px) / 2)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-disabled-selected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control+.mdc-radio__background .mdc-radio__inner-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-disabled-selected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:checked+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:checked+.mdc-radio__background .mdc-radio__outer-circle{opacity:var(--mdc-radio-disabled-selected-icon-opacity, 0.38)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control+.mdc-radio__background .mdc-radio__inner-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled+.mdc-radio__background .mdc-radio__inner-circle{opacity:var(--mdc-radio-disabled-selected-icon-opacity, 0.38)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-disabled-unselected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio [aria-disabled=true] .mdc-radio__native-control:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:disabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{opacity:var(--mdc-radio-disabled-unselected-icon-opacity, 0.38)}.mat-mdc-radio-button .mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle,.mat-mdc-radio-button .mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-focus-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio.mdc-ripple-upgraded--background-focused .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle,.mat-mdc-radio-button .mdc-radio:not(.mdc-ripple-upgraded):focus .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-focus-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-hover-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-hover-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:not(:disabled):active .mdc-radio__native-control:enabled:checked+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-selected-pressed-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:not(:disabled):active .mdc-radio__native-control:enabled+.mdc-radio__background .mdc-radio__inner-circle{border-color:var(--mdc-radio-selected-pressed-icon-color, #6200ee)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:enabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-hover-icon-color, #000)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:enabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-icon-color, #000)}.mat-mdc-radio-button .mdc-radio:not(:disabled):active .mdc-radio__native-control:enabled:not(:checked)+.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-pressed-icon-color, #000)}.mat-mdc-radio-button .mdc-radio .mdc-radio__background::before{top:calc(-1 * (var(--mdc-radio-state-layer-size, 40px) - 20px) / 2);left:calc(-1 * (var(--mdc-radio-state-layer-size, 40px) - 20px) / 2);width:var(--mdc-radio-state-layer-size, 40px);height:var(--mdc-radio-state-layer-size, 40px)}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control{top:calc((var(--mdc-radio-state-layer-size, 40px) - var(--mdc-radio-state-layer-size, 40px)) / 2);right:calc((var(--mdc-radio-state-layer-size, 40px) - var(--mdc-radio-state-layer-size, 40px)) / 2);left:calc((var(--mdc-radio-state-layer-size, 40px) - var(--mdc-radio-state-layer-size, 40px)) / 2);width:var(--mdc-radio-state-layer-size, 40px);height:var(--mdc-radio-state-layer-size, 40px)}.mat-mdc-radio-button .mdc-radio .mdc-radio__background::before{background-color:var(--mat-mdc-radio-ripple-color, transparent)}.mat-mdc-radio-button .mdc-radio:hover .mdc-radio__native-control:not([disabled]):not(:focus)~.mdc-radio__background::before{opacity:.04;transform:scale(1)}.mat-mdc-radio-button.mat-mdc-radio-checked .mdc-radio__background::before{background-color:var(--mat-mdc-radio-checked-ripple-color, transparent)}.mat-mdc-radio-button.mat-mdc-radio-checked .mat-ripple-element{background-color:var(--mat-mdc-radio-checked-ripple-color, transparent)}.mat-mdc-radio-button .mat-radio-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none;border-radius:50%}.mat-mdc-radio-button .mat-radio-ripple .mat-ripple-element{opacity:.14}.mat-mdc-radio-button .mat-radio-ripple::before{border-radius:50%}.mat-mdc-radio-button._mat-animation-noopable .mdc-radio__background::before,.mat-mdc-radio-button._mat-animation-noopable .mdc-radio__outer-circle,.mat-mdc-radio-button._mat-animation-noopable .mdc-radio__inner-circle{transition:none !important}.mat-mdc-radio-button .mdc-radio .mdc-radio__native-control:focus:enabled:not(:checked)~.mdc-radio__background .mdc-radio__outer-circle{border-color:var(--mdc-radio-unselected-focus-icon-color, black)}.mat-mdc-radio-button.cdk-focused .mat-mdc-focus-indicator::before{content:\"\"}.mat-mdc-radio-touch-target{position:absolute;top:50%;height:48px;left:50%;width:48px;transform:translate(-50%, -50%)}[dir=rtl] .mat-mdc-radio-touch-target{left:0;right:50%;transform:translate(50%, -50%)}"]
                }]
              }], function () {
                return [{
                  type: MatRadioGroup,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_RADIO_GROUP]
                  }]
                }, {
                  type: i0.ElementRef
                }, {
                  type: i0.ChangeDetectorRef
                }, {
                  type: i1.FocusMonitor
                }, {
                  type: i2.UniqueSelectionDispatcher
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [ANIMATION_MODULE_TYPE]
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Optional
                  }, {
                    type: Inject,
                    args: [MAT_RADIO_DEFAULT_OPTIONS]
                  }]
                }, {
                  type: undefined,
                  decorators: [{
                    type: Attribute,
                    args: ['tabindex']
                  }]
                }];
              }, null);
            })();

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatRadioModule {} exports('MatRadioModule', MatRadioModule);
            MatRadioModule.ɵfac = function MatRadioModule_Factory(t) {
              return new (t || MatRadioModule)();
            };
            MatRadioModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatRadioModule
            });
            MatRadioModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              imports: [MatCommonModule, CommonModule, MatRippleModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatRadioModule, [{
                type: NgModule,
                args: [{
                  imports: [MatCommonModule, CommonModule, MatRippleModule],
                  exports: [MatCommonModule, MatRadioGroup, MatRadioButton],
                  declarations: [MatRadioGroup, MatRadioButton]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-radio.js.map
