/* esm-bundle - @angular/material/toolbar@15.2.9 - Ivy - system format - es2020 - Use of this source code is governed by an MIT-style license that can be found in the LICENSE file at https://angular.io/license */
System.register(['@angular/core', '@angular/material/core', '@angular/cdk/platform', '@angular/common'], (function (exports) {
    'use strict';
    var i0, Directive, Component, ChangeDetectionStrategy, ViewEncapsulation, Inject, ContentChildren, NgModule, mixinColor, MatCommonModule, i1, DOCUMENT;
    return {
        setters: [function (module) {
            i0 = module;
            Directive = module.Directive;
            Component = module.Component;
            ChangeDetectionStrategy = module.ChangeDetectionStrategy;
            ViewEncapsulation = module.ViewEncapsulation;
            Inject = module.Inject;
            ContentChildren = module.ContentChildren;
            NgModule = module.NgModule;
        }, function (module) {
            mixinColor = module.mixinColor;
            MatCommonModule = module.MatCommonModule;
        }, function (module) {
            i1 = module;
        }, function (module) {
            DOCUMENT = module.DOCUMENT;
        }],
        execute: (function () {

            exports('throwToolbarMixedModesError', throwToolbarMixedModesError);

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            // Boilerplate for applying mixins to MatToolbar.
            /** @docs-private */
            const _c0 = ["*", [["mat-toolbar-row"]]];
            const _c1 = ["*", "mat-toolbar-row"];
            const _MatToolbarBase = mixinColor(class {
              constructor(_elementRef) {
                this._elementRef = _elementRef;
              }
            });
            class MatToolbarRow {} exports('MatToolbarRow', MatToolbarRow);
            MatToolbarRow.ɵfac = function MatToolbarRow_Factory(t) {
              return new (t || MatToolbarRow)();
            };
            MatToolbarRow.ɵdir = /* @__PURE__ */i0.ɵɵdefineDirective({
              type: MatToolbarRow,
              selectors: [["mat-toolbar-row"]],
              hostAttrs: [1, "mat-toolbar-row"],
              exportAs: ["matToolbarRow"]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatToolbarRow, [{
                type: Directive,
                args: [{
                  selector: 'mat-toolbar-row',
                  exportAs: 'matToolbarRow',
                  host: {
                    'class': 'mat-toolbar-row'
                  }
                }]
              }], null, null);
            })();
            class MatToolbar extends _MatToolbarBase {
              constructor(elementRef, _platform, document) {
                super(elementRef);
                this._platform = _platform;
                // TODO: make the document a required param when doing breaking changes.
                this._document = document;
              }
              ngAfterViewInit() {
                if (this._platform.isBrowser) {
                  this._checkToolbarMixedModes();
                  this._toolbarRows.changes.subscribe(() => this._checkToolbarMixedModes());
                }
              }
              /**
               * Throws an exception when developers are attempting to combine the different toolbar row modes.
               */
              _checkToolbarMixedModes() {
                if (this._toolbarRows.length && (typeof ngDevMode === 'undefined' || ngDevMode)) {
                  // Check if there are any other DOM nodes that can display content but aren't inside of
                  // a <mat-toolbar-row> element.
                  const isCombinedUsage = Array.from(this._elementRef.nativeElement.childNodes).filter(node => !(node.classList && node.classList.contains('mat-toolbar-row'))).filter(node => node.nodeType !== (this._document ? this._document.COMMENT_NODE : 8)).some(node => !!(node.textContent && node.textContent.trim()));
                  if (isCombinedUsage) {
                    throwToolbarMixedModesError();
                  }
                }
              }
            } exports('MatToolbar', MatToolbar);
            MatToolbar.ɵfac = function MatToolbar_Factory(t) {
              return new (t || MatToolbar)(i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1.Platform), i0.ɵɵdirectiveInject(DOCUMENT));
            };
            MatToolbar.ɵcmp = /* @__PURE__ */i0.ɵɵdefineComponent({
              type: MatToolbar,
              selectors: [["mat-toolbar"]],
              contentQueries: function MatToolbar_ContentQueries(rf, ctx, dirIndex) {
                if (rf & 1) {
                  i0.ɵɵcontentQuery(dirIndex, MatToolbarRow, 5);
                }
                if (rf & 2) {
                  let _t;
                  i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx._toolbarRows = _t);
                }
              },
              hostAttrs: [1, "mat-toolbar"],
              hostVars: 4,
              hostBindings: function MatToolbar_HostBindings(rf, ctx) {
                if (rf & 2) {
                  i0.ɵɵclassProp("mat-toolbar-multiple-rows", ctx._toolbarRows.length > 0)("mat-toolbar-single-row", ctx._toolbarRows.length === 0);
                }
              },
              inputs: {
                color: "color"
              },
              exportAs: ["matToolbar"],
              features: [i0.ɵɵInheritDefinitionFeature],
              ngContentSelectors: _c1,
              decls: 2,
              vars: 0,
              template: function MatToolbar_Template(rf, ctx) {
                if (rf & 1) {
                  i0.ɵɵprojectionDef(_c0);
                  i0.ɵɵprojection(0);
                  i0.ɵɵprojection(1, 1);
                }
              },
              styles: [".cdk-high-contrast-active .mat-toolbar{outline:solid 1px}.mat-toolbar .mat-mdc-button-base.mat-unthemed{--mdc-text-button-label-text-color: inherit;--mdc-outlined-button-label-text-color: inherit}.mat-toolbar-row,.mat-toolbar-single-row{display:flex;box-sizing:border-box;padding:0 16px;width:100%;flex-direction:row;align-items:center;white-space:nowrap}.mat-toolbar-multiple-rows{display:flex;box-sizing:border-box;flex-direction:column;width:100%}"],
              encapsulation: 2,
              changeDetection: 0
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatToolbar, [{
                type: Component,
                args: [{
                  selector: 'mat-toolbar',
                  exportAs: 'matToolbar',
                  inputs: ['color'],
                  host: {
                    'class': 'mat-toolbar',
                    '[class.mat-toolbar-multiple-rows]': '_toolbarRows.length > 0',
                    '[class.mat-toolbar-single-row]': '_toolbarRows.length === 0'
                  },
                  changeDetection: ChangeDetectionStrategy.OnPush,
                  encapsulation: ViewEncapsulation.None,
                  template: "<ng-content></ng-content>\n<ng-content select=\"mat-toolbar-row\"></ng-content>\n",
                  styles: [".cdk-high-contrast-active .mat-toolbar{outline:solid 1px}.mat-toolbar .mat-mdc-button-base.mat-unthemed{--mdc-text-button-label-text-color: inherit;--mdc-outlined-button-label-text-color: inherit}.mat-toolbar-row,.mat-toolbar-single-row{display:flex;box-sizing:border-box;padding:0 16px;width:100%;flex-direction:row;align-items:center;white-space:nowrap}.mat-toolbar-multiple-rows{display:flex;box-sizing:border-box;flex-direction:column;width:100%}"]
                }]
              }], function () {
                return [{
                  type: i0.ElementRef
                }, {
                  type: i1.Platform
                }, {
                  type: undefined,
                  decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                  }]
                }];
              }, {
                _toolbarRows: [{
                  type: ContentChildren,
                  args: [MatToolbarRow, {
                    descendants: true
                  }]
                }]
              });
            })();
            /**
             * Throws an exception when attempting to combine the different toolbar row modes.
             * @docs-private
             */
            function throwToolbarMixedModesError() {
              throw Error('MatToolbar: Attempting to combine different toolbar modes. ' + 'Either specify multiple `<mat-toolbar-row>` elements explicitly or just place content ' + 'inside of a `<mat-toolbar>` for a single row.');
            }

            /**
             * @license
             * Copyright Google LLC All Rights Reserved.
             *
             * Use of this source code is governed by an MIT-style license that can be
             * found in the LICENSE file at https://angular.io/license
             */
            class MatToolbarModule {} exports('MatToolbarModule', MatToolbarModule);
            MatToolbarModule.ɵfac = function MatToolbarModule_Factory(t) {
              return new (t || MatToolbarModule)();
            };
            MatToolbarModule.ɵmod = /* @__PURE__ */i0.ɵɵdefineNgModule({
              type: MatToolbarModule
            });
            MatToolbarModule.ɵinj = /* @__PURE__ */i0.ɵɵdefineInjector({
              imports: [MatCommonModule, MatCommonModule]
            });
            (function () {
              (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MatToolbarModule, [{
                type: NgModule,
                args: [{
                  imports: [MatCommonModule],
                  exports: [MatToolbar, MatToolbarRow, MatCommonModule],
                  declarations: [MatToolbar, MatToolbarRow]
                }]
              }], null, null);
            })();

        })
    };
}));
//# sourceMappingURL=angular-toolbar.js.map
